package teajay.bytecode;

import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.cpool.ConstantPool;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 * A class implementing this interface is part of a class file and can be written as a stream of bytes.
 * @author Michael Kußmann <michi@outx.de>
 */
public interface ByteCodeWritable {
    /**
     * Writes the byte code representation of this entity to <code> out </code>.
     * @param out the destination stream
     * @param cpool the value of cpool
     * @throws IOException if out throws an <tt>IOException</tt>
     * @throws ByteCodeException if the entity not yet holds all required information or the content does not meet certain constraints
     */
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException;
}
