package teajay.bytecode;

/**
 * Implements the valid access flags for the public class inside a class file.
 * @author Michael Kußmann <michi@outx.de>
 */
public enum ClassAccessFlag implements AccessFlag {
    PACKAGE_PRIVATE(0x0000),
    PUBLIC(0x0001),
    FINAL(0x0010),
    SUPER(0x0020),
    INTERFACE(0x0200),
    ABSTRACT(0x0400),
    SYNTHETIC(0x1000),
    ANNOTATION(0x2000),
    ENUM(0x4000),
    MODULE(0x8000);
  
    public final int intValue;

    private ClassAccessFlag(int value) {
        this.intValue = value;
    }

    @Override
    public int getIntValue() {
        return intValue;
    }
}
