package teajay.bytecode;

import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.cpool.ConstantPool;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public interface IndexWritable extends ByteCodeWritable {

    /**
     * Writes this entity's value as an operand.
     *
     * @param out the destination stream
     * @param cpool the value of cpool
     * @throws IOException if the stream throws an IOException
     * @throws ByteCodeException if the required data to calculate the result is
     * not yet available
     */
    public abstract void writeIndex(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException;
}
