package teajay.bytecode;

/**
 * Implements the valid access flags for nested classes.
 * @author Michael Kußmann <michi@outx.de>
 */
public enum InnerClassAccessFlag implements AccessFlag {
    PACKAGE_PRIVATE(0x0000),
    PUBLIC(0x0001),
    PRIVATE(0x0002),
    PROTECTED(0x0004),
    STATIC(0x0008),
    FINAL(0x0010),
    INTERFACE(0x0200),
    ABSTRACT(0x0400),
    SYNTHETIC(0x1000),
    ANNOTATION(0x2000),
    ENUM(0x4000);
    
    public final int intValue;

    private InnerClassAccessFlag(int value) {
        this.intValue = value;
    }

    @Override
    public int getIntValue() {
        return intValue;
    }
    
}
