package teajay.bytecode.attributes.annotations;

import java.io.DataInputStream;
import java.io.IOException;
import teajay.bytecode.cpool.ConstantPool;
import teajay.bytecode.cpool.Utf8Info;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class RuntimeVisibleAnnotations extends RuntimeAnnotation {
    public static final String NAME = "RuntimeVisibleAnnotations";
    
    public RuntimeVisibleAnnotations() {
        this(new Utf8Info(NAME));
    }
    
    private RuntimeVisibleAnnotations(Utf8Info name, Annotation... annotations) {
        super(name, annotations);
        checkName(NAME, name);
    }
    
    public static RuntimeVisibleAnnotations read(DataInputStream in, ConstantPool cpool, int major, int minor, int length, Utf8Info name) throws ByteCodeException, IOException {
        Annotation[] annotations = RuntimeAnnotation.read(in, cpool, major, minor);
        return new RuntimeVisibleAnnotations(name, annotations);
    }
}
