package teajay.bytecode.attributes.annotations;

import java.io.DataInputStream;
import java.io.IOException;
import java.util.List;
import teajay.bytecode.cpool.ConstantPool;
import teajay.bytecode.cpool.Utf8Info;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class RuntimeVisibleParameterAnnotations extends RuntimeParameterAnnotation {

    public static final String NAME = "RuntimeVisibleParameterAnnotations";

    public RuntimeVisibleParameterAnnotations() {
        super(new Utf8Info(NAME));
    }
    
    private RuntimeVisibleParameterAnnotations(Utf8Info name, List<List<Annotation>> annotations) {
        super(name, annotations);
        checkName(NAME, name);
    }
    
    public static RuntimeVisibleParameterAnnotations read(DataInputStream in, ConstantPool cpool, int major, int minor, int length, Utf8Info name) throws ByteCodeException, IOException {
        List<List<Annotation>> annotations = RuntimeParameterAnnotation.read(in, cpool, major, minor);
        return new RuntimeVisibleParameterAnnotations(name, annotations);
    }
}
