package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public enum FPMode {
    g(OpCode.dcmpg, OpCode.fcmpg),
    l(OpCode.dcmpl, OpCode.fcmpl);
    
    private final OpCode[] opcode;
    
    private FPMode(OpCode... opcode) {
        this.opcode = opcode;
    }
    
    OpCode getForDCmp() {
        return opcode[0];
    }
    
    OpCode getForFCmp() {
        return opcode[1];
    }    
}
