package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.FieldRefInfo;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class GetInstruction extends SimpleInstruction {
    private final int push;
    
    public GetInstruction(FieldRefInfo field, boolean isStatic) {
        this.setOpcode(isStatic ? OpCode.getstatic : OpCode.getfield);
        this.setOperands(field);
        FieldDescriptor descr = field.getNameAndType().getDescriptor();
        if (descr.isLongOrDouble()) {
            this.push = 2;
        } else {
            this.push = 1;
        }
    }
    
    @Override
    int getPush() {
        return push;
    }

    @Override
    int getLocalModifier() {
        return 0;
    }
    
}
