package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public enum IMode {

    eq(OpCode.if_icmpeq, OpCode.ifeq),
    ne(OpCode.if_icmpne, OpCode.ifne),
    lt(OpCode.if_icmplt, OpCode.iflt),
    ge(OpCode.if_icmpge, OpCode.ifge),
    gt(OpCode.if_icmpgt, OpCode.ifgt),
    le(OpCode.if_icmple, OpCode.ifle);
    
    final OpCode[] opcode;

    private IMode(OpCode... code) {
        this.opcode = code;
    }

    public IMode negate() {
        switch (this) {
            case eq:
                return ne;
            case ne:
                return eq;
            case lt:
                return ge;
            case ge:
                return lt;
            case gt:
                return le;
            case le:
                return gt;
            default:
                throw new RuntimeException("Unreachable switch statement reached!");
        }
    }
    
    OpCode getForIfICmp() {
        return opcode[0];
    }
    
    OpCode getForIf0() {
        return opcode[1];
    }

}
