package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;
import teajay.bytecode.U1;
import teajay.bytecode.cpool.InterfaceMethodRefInfo;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class InvokeInterface extends InvokeInstruction {
    private final int pop;
    
    public InvokeInterface(InterfaceMethodRefInfo method) throws ByteCodeException {
        super(method, OpCode.invokeinterface);
        this.pop = super.getPop();
        if (pop > 0xFF) {
            throw new ByteCodeException("invokeinterface: count argument out of bounds: " + pop);
        }
        this.setOperands(method, new U1(pop), U1.ZERO);
    }
    
    @Override
    int getPop() {
        return pop;
    }

    @Override
    int getLocalModifier() {
        return 0;
    }
}
