package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;
import teajay.bytecode.U1;
import teajay.bytecode.cpool.ClassInfo;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class MultiANewArray extends SimpleInstruction {

    public MultiANewArray(ClassInfo type, int dimension) throws ByteCodeException {
        this.setOpcode(OpCode.multianewarray);
        if (dimension <= 255 && dimension >= 1) {
            this.setOperands(type, new U1(dimension));
        } else {
            throw new ByteCodeException("multianewarray: Array dimension out of bounds " + dimension + ".");
        }
    }

    @Override
    int getLocalModifier() {
        return 0;
    }
}
