package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;

/**
 * Implements the newarray instruction.
 * @author Michael Kußmann <michi@outx.de>
 */
public class NewArray extends SimpleInstruction {
    /**
     * Creates a new newarray instruction for an array of <code>type</code>.
     * @param type the array type
     */
    public NewArray(ArrayType type) {
        this.setOpcode(OpCode.newarray);
        this.setOperands(type);
    }

    @Override
    int getLocalModifier() {
        return 0;
    }
    
}
