package teajay.bytecode.attributes.code;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Collections;
import java.util.List;
import teajay.bytecode.U1;
import teajay.bytecode.U4;
import teajay.bytecode.cpool.ConstantPool;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
final class SameFrameExtended extends StackMapFrame {
    public static final int FRAME_TYPE = 251;

    SameFrameExtended(JVMInstruction start) {
        super(start);
    }

    @Override
    U1 getFrameType() throws ByteCodeException {
        return new U1(FRAME_TYPE);
    }

    @Override
    public void add(ConstantPool cpool) throws ByteCodeException {
    }

    @Override
    U4 getLength() throws ByteCodeException {
        return new U4(1 + 2);
    }

    @Override
    List<VerificationType> getStack() throws ByteCodeException {
        return Collections.emptyList();
    }

    @Override
    List<VerificationType> getLocals() throws ByteCodeException {
        return this.getPredecessor().getLocals();
    }
    
    @Override
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException {
        super.write(out, cpool);
        offsetDelta().write(out, cpool);
    }
}
