package teajay.bytecode.cpool;

import teajay.bytecode.exceptions.ByteCodeException;

/**
 * All classes that may contain constant pool entities should implement this interface.
 * @author Michael Kußmann <michi@outx.de>
 */
public interface ConstantPoolAddable {
    /**
     * This method adds all constant pool entities known by the implementing class into <tt>cpool</tt>.
     * @param cpool the constant pool to add all entities
     * @throws ByteCodeException if the constant pool capacity is exceeded or the implementing class is not in a state where it has all required information
     */
    public void add(ConstantPool cpool) throws ByteCodeException;
}
