package teajay.bytecode.cpool;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class DoubleInfo extends U8Info {
    public DoubleInfo(double value) {
        super(CPoolTag.Double, Double.doubleToRawLongBits(value));
    }
    
    public double getDoubleValue() {
        return Double.longBitsToDouble(this.getRawValue());
    }
    
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + ": " + this.getDoubleValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof DoubleInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 79 * super.hashCode();
        return hash;
    }
}
