package teajay.bytecode.cpool;

import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
final class DummyEntry extends CPoolEntry {
    DummyEntry() {
        super(CPoolTag.Dummy);
    }
    
    @Override
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException {
        //Nothing to do here
    }
    
    @Override
    public void writeIndex(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException {
        throw new ByteCodeException("trying to write the index of a dummy entry");
    }
    
    @Override
    public String toString() {
        return "DummyEntry";
    }
    
    @Override
    public DummyEntry clone() {
        return new DummyEntry();
    }
}
