package teajay.bytecode.cpool;

import teajay.bytecode.U2;
import teajay.bytecode.attributes.bootstrap.BootstrapMethodEntry;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 * Supported since class file major version 55 (Java 11)
 * This class is not cloneable!
 * @author Michael Kußmann <michi@outx.de>
 */
public final class DynamicInfo extends AbstractDynamicInfo {
    
    public DynamicInfo(BootstrapMethodEntry bootstrapMethod, NameAndTypeInfo<MethodDescriptor> nameAndType) throws ByteCodeException {
        super(CPoolTag.Dynamic, bootstrapMethod.getIndex(), nameAndType);
    }
    
    DynamicInfo(U2 bootstrapIndex, NameAndTypeInfo<MethodDescriptor> nameAndType) throws ByteCodeException {
        super(CPoolTag.Dynamic, bootstrapIndex, nameAndType);
    }
}
