package teajay.bytecode.cpool;

import teajay.bytecode.exceptions.MalformedClassNameException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class FieldRefInfo extends CPoolRef<FieldDescriptor> {
    
    public static FieldRefInfo make(ClassInfo className, String name, FieldDescriptor type) {
        return new FieldRefInfo(className, new NameAndTypeInfo<>(name, type));
    }
    
    public static FieldRefInfo make(String className, String name, FieldDescriptor type) throws MalformedClassNameException {
        return new FieldRefInfo(new ClassInfo(className), new NameAndTypeInfo<>(name, type));
    }
    
    public static FieldRefInfo make(String className, String name, String type) throws MalformedClassNameException {
        return new FieldRefInfo(new ClassInfo(className), new NameAndTypeInfo<>(name, FieldDescriptor.fromString(type)));
    }
    
    public FieldRefInfo(ClassInfo className, NameAndTypeInfo<FieldDescriptor> nameAndType) {
        super(CPoolTag.FieldRef, className, nameAndType);
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof FieldRefInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        return 71 * super.hashCode();
    }
}
