package teajay.bytecode.cpool;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class FloatInfo extends U4Info {
    public FloatInfo(float value) {
        super(CPoolTag.Float, Float.floatToRawIntBits(value));
    }
    
    public float getFloatValue() {
        return Float.intBitsToFloat(this.getRawValue());
    }
    
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + ": " + this.getFloatValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof FloatInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 67 * super.hashCode();
        return hash;
    }
    
    @Override
    public FloatInfo clone() {
        return new FloatInfo(getFloatValue());
    }
}
