package teajay.bytecode.cpool;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class IntegerInfo extends U4Info {
    public IntegerInfo(int value) {
        super(CPoolTag.Integer, value);
    }
       
    public IntegerInfo(boolean value) {
        super(CPoolTag.Integer, value ? 1 : 0);
    }
    
    public int getIntegerValue() {
        return getRawValue();
    }
    
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + ": " + this.getIntegerValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof IntegerInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 61 * super.hashCode();
        return hash;
    }
    
    @Override
    public IntegerInfo clone() {
        return new IntegerInfo(getIntegerValue());
    }
}
