package teajay.bytecode.cpool;

import teajay.bytecode.U2;
import teajay.bytecode.attributes.bootstrap.BootstrapMethodEntry;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 * Implements the constant pool entry that serves as argument for a
 * invokedynamic instruction. This class is not cloneable!
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class InvokeDynamicInfo extends AbstractDynamicInfo {

    public InvokeDynamicInfo(BootstrapMethodEntry bootstrapMethod, NameAndTypeInfo<MethodDescriptor> nameAndType) throws ByteCodeException {
        super(CPoolTag.InvokeDynamic, bootstrapMethod.getIndex(), nameAndType);
    }

    InvokeDynamicInfo(U2 bootstrapIndex, NameAndTypeInfo<MethodDescriptor> nameAndType) throws ByteCodeException {
        super(CPoolTag.InvokeDynamic, bootstrapIndex, nameAndType);
    }
}
