package teajay.bytecode.cpool;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class MethodTypeInfo extends U1U2Entry<Utf8Info> {
    private final MethodDescriptor descriptor;
    
    public MethodTypeInfo(MethodDescriptor descriptor) {
        super(CPoolTag.MethodType, descriptor);
        this.descriptor = descriptor;
    }
    
    public MethodDescriptor getMethodDescriptor() {
        return descriptor;
    }
       
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof MethodTypeInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 31 * super.hashCode();
        return hash;
    }
}
