package teajay.bytecode.cpool;

import teajay.bytecode.exceptions.UTFOutOfBoundsException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class StringInfo extends U1U2Entry<Utf8Info> {
    public StringInfo(Utf8Info value) {
        super(CPoolTag.String, value);
    }
    
    public StringInfo(String value) throws UTFOutOfBoundsException {
        super(CPoolTag.String, new Utf8Info(value));
    }
    
    public String getString() {
        return getValue().getValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof StringInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 19 * super.hashCode();
        return hash;
    }
}
