package teajay.bytecode.cpool;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.OpCode.OpSize;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class U2Index extends CPoolIndex {

    U2Index(int index) {
        super(index);
    }

    @Override
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException {
        out.writeShort(this.getValue());
    }
    
    @Override
    public void writeIndex(DataOutputStream out, ConstantPool cpool) throws IOException {
        write(out, cpool);
    }    

    @Override
    public U1Index toU1Index() {
        return new U1Index(getValue());
    }

    @Override
    public U2Index toU2Index() {
        return this;
    }

    @Override
    public OpSize getDefaultLengthAsOperand() {
        return OpSize.U2;
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof U2Index) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 79 * super.hashCode();
        return hash;
    }
    
    public static U2Index read(DataInputStream in) throws IOException {
        return new U2Index(in.readUnsignedShort());
    }
}
