package teajay.bytecode.cpool;

import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
abstract class U4Info extends CPoolEntry {
    
    private final int value;
    
    protected U4Info(CPoolTag tag, int value) {
        super(tag);
        this.value = value;
    }
    
    public final int getRawValue() {
        return value;
    }

    @Override
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException {
        super.write(out, cpool);
        out.writeInt(value);
    }
    
    @Override
    public boolean equals(Object obj) {
        if ( (obj instanceof U4Info) && super.equals(obj) ) {
            return ((U4Info) obj).value == value;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        int hash = 9 * super.hashCode();
        hash = 13 * hash + this.value;
        return hash;
    }
}
