package teajay.bytecode.cpool;

import java.io.DataOutputStream;
import java.io.IOException;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
abstract class U8Info extends CPoolEntry {
    private final long value;
    
    protected U8Info(CPoolTag tag, long value) {
        super(tag);
        this.value = value;
    }
    
    public final long getRawValue() {
        return value;
    }

    @Override
    public void write(DataOutputStream out, ConstantPool cpool) throws IOException, ByteCodeException {
        super.write(out, cpool);
        out.writeLong(value);
    }
    
    @Override
    public boolean equals(Object obj) {
        if ( (obj instanceof U8Info) && super.equals(obj) ) {
            return ((U8Info) obj).value == value;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        int hash = 7 * super.hashCode();
        hash = 89 * hash + (int) (this.value ^ (this.value >>> 32));
        return hash;
    }
}
