package teajay.bytecode.fields;

import teajay.bytecode.AccessFlag;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public enum FieldAccessFlag implements AccessFlag {
    PACKAGE_PRIVATE(0x0000),
    PUBLIC(0x0001),
    PRIVATE(0x0002),
    PROTECTED(0x0004),
    STATIC(0x0008),
    FINAL(0x0010),
    VOLATILE(0x0040),
    TRANSIENT(0x0080),
    SYNTHETIC(0x1000),
    ENUM(0x4000);
    
    public final int intValue;

    private FieldAccessFlag(int value) {
        this.intValue = value;
    }

    @Override
    public int getIntValue() {
        return intValue;
    }
}
