package teajay.bytecode.util;

import java.util.Iterator;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class UnmodifiableIterator<T> implements Iterator<T> {
    private final Iterator<T> it;
    
    public UnmodifiableIterator(Iterator<T> it) {
        this.it = it;
    }
    
    @Override
    public boolean hasNext() {
        return it.hasNext();
    }

    @Override
    public T next() {
        return it.next();
    }

    @Override
    public void remove() {
        throw new UnsupportedOperationException("This iterator is unmodifiable.");
    }
}
