/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import exceptions.CompilerException;
import lexer.Symbol;

/**
 *
 * @author Michael Burzan
 */
public class AnnotationElementNode extends SyntaxNode {

    private ElementValuePairsNode pairs = null;
    private ElementValueNode value = null;

    public AnnotationElementNode(Symbol s, ElementValuePairsNode pairs) {
        super(s);
        this.pairs = pairs;
    }

    public AnnotationElementNode(Symbol s, ElementValueNode value) {
        super(s);
        this.value = value;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.pairs, v);
        checkNull(this.value, v);
        visitor.end(this);
    }

    public String toString() {
        return "";
    }
}
