/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import exceptions.CompilerException;
import lexer.Symbol;

/**
 *
 * @author Michael Burzan
 */
public class AnnotationMethodRestNode extends SyntaxNode {

    private boolean hasEdges = false;
    private ElementValueNode elementValue = null;

    public AnnotationMethodRestNode(Symbol s) {
        super(s);
    }

    public AnnotationMethodRestNode(Symbol s, boolean hasEdges) {
        super(s);
        this.hasEdges = hasEdges;
    }

    public AnnotationMethodRestNode(Symbol s, boolean hasEdges, ElementValueNode elementValue) {
        super(s);
        this.hasEdges = hasEdges;
        this.elementValue = elementValue;
    }

    public AnnotationMethodRestNode(Symbol s, ElementValueNode elementValue) {
        super(s);
        this.elementValue = elementValue;
    }

    public boolean hasEdges() {
        return this.hasEdges;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.elementValue, v);
        visitor.end(this);
    }
}
