/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import exceptions.CompilerException;
import lexer.Symbol;

/**
 *
 * @author Michael Burzan
 */
public class AnnotationTypeElementRestNode extends SyntaxNode {

    private TypeNode type = null;
    private String identifier = null;
    private AnnotationMethodOrConstantRestNode annotationMethodOrConstantRest = null;
    private ClassDeclarationNode classDeclaration = null;
    private InterfaceDeclarationNode interfaceDeclaration = null;
    private EnumDeclarationNode enumDeclaration = null;
    private AnnotationTypeDeclarationNode annotationTypeDeclaration = null;

    public AnnotationTypeElementRestNode(Symbol s, TypeNode type, String identifier,
            AnnotationMethodOrConstantRestNode annotationMethodOrConstantRest) {
        super(s);
        this.type = type;
        this.identifier = identifier;
        this.annotationMethodOrConstantRest = annotationMethodOrConstantRest;
    }

    public AnnotationTypeElementRestNode(Symbol s, ClassDeclarationNode classDeclaration) {
        super(s);
        this.classDeclaration = classDeclaration;
    }

    public AnnotationTypeElementRestNode(Symbol s, InterfaceDeclarationNode interfaceDeclaration) {
        super(s);
        this.interfaceDeclaration = interfaceDeclaration;
    }

    public AnnotationTypeElementRestNode(Symbol s, EnumDeclarationNode enumDeclaration) {
        super(s);
        this.enumDeclaration = enumDeclaration;
    }

    public AnnotationTypeElementRestNode(Symbol s, AnnotationTypeDeclarationNode annotationTypeDeclaration) {
        super(s);
        this.annotationTypeDeclaration = annotationTypeDeclaration;
    }

    public String getIdentifier() {
        return this.identifier;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.type, v);
        checkNull(this.annotationMethodOrConstantRest, v);
        checkNull(this.classDeclaration, v);
        checkNull(this.interfaceDeclaration, v);
        checkNull(this.enumDeclaration, v);
        checkNull(this.annotationTypeDeclaration, v);
        visitor.end(this);
    }
}
