/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import exceptions.CompilerException;
import java.util.LinkedList;
import lexer.Symbol;

/**
 *
 * @author Michael Burzan
 *
 */
public class ArrayCreatorRestNode extends SyntaxNode {

    private int edgeClampsOpen = 0;
    private ArrayInitializerNode arrayInit = null;
    private ExpressionNode head = null;
    private LinkedList<ExpressionNode> expressionList = null;

    public ArrayCreatorRestNode(Symbol s, int edgeClampsOpen, ArrayInitializerNode arrayInit) {
        super(s);
        this.edgeClampsOpen = edgeClampsOpen;
        this.arrayInit = arrayInit;
    }

    public ArrayCreatorRestNode(Symbol s, ExpressionNode head,
            LinkedList<ExpressionNode> expressionList,
            int edgeClampsOpen) {
        super(s);
        this.head = head;
        this.expressionList = expressionList;
        this.edgeClampsOpen = edgeClampsOpen;
    }

    public int getDim() {
        return this.edgeClampsOpen;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.arrayInit, v);
        checkNull(this.head, v);
        checkNull(this.expressionList, v);
        visitor.end(this);
    }
}
