/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.LinkedList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class CreatedNameNode extends SyntaxNode {

    private String identifier = null;
    private TypeArgumentsOrDiamondNode typeArgumentsOrDiamond = null;
    private BasicTypeNode baseType = null;

    public void setIdentifier(String importName) {
        this.identifier = importName;
    }

    public static class IdentTypeArgumentsOrDiamondNode extends SyntaxNode {

        private String identifier;
        private TypeArgumentsOrDiamondNode typeArgumentsOrDiamond = null;

        public IdentTypeArgumentsOrDiamondNode(Symbol s, String identString) {
            super(s);
            this.identifier = identString;
        }

        public IdentTypeArgumentsOrDiamondNode(Symbol s, String identString,
                TypeArgumentsOrDiamondNode typeArgumentsOrDiamond) {
            super(s);
            this.identifier = identString;
            this.typeArgumentsOrDiamond = typeArgumentsOrDiamond;
        }

        public String getIdentifier() {
            return this.identifier;
        }

        @Override
        public void accept(Visitor visitor) throws CompilerException {
            visitor.begin(this);
            Visitor v = visitor.visit(this);
            checkNull(this.typeArgumentsOrDiamond, v);
            visitor.end(this);
        }
        
        @Override
        public String toString() {
            return identifier;
        }
    }
    private LinkedList<IdentTypeArgumentsOrDiamondNode> identTypeArgOrDiaList;

   
    
    
    
    public CreatedNameNode(Symbol s, String identifier,
            TypeArgumentsOrDiamondNode typeArgumentsOrDiamond,
            LinkedList<IdentTypeArgumentsOrDiamondNode> identTypeArgOrDiaList) {
        super(s);
        this.identifier = identifier;
        this.typeArgumentsOrDiamond = typeArgumentsOrDiamond;
        this.identTypeArgOrDiaList = identTypeArgOrDiaList;
    }

    public CreatedNameNode(Symbol s, String identifier,
            LinkedList<IdentTypeArgumentsOrDiamondNode> identTypeArgOrDiaList) {
        super(s);
        this.identifier = identifier;
        this.identTypeArgOrDiaList = identTypeArgOrDiaList;
    }

    public CreatedNameNode(Symbol s, BasicTypeNode baseType) {
        super(s);
        this.baseType = baseType;
    }

    public String getIdentifier() {
        return this.identifier;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.typeArgumentsOrDiamond, v);
        checkNull(this.identTypeArgOrDiaList, v);
        /*
        if (identTypeArgOrDiaList != null) {
            for (IdentTypeArgumentsOrDiamondNode l : identTypeArgOrDiaList) {
                l.accept(v);
            }
        }*/
        visitor.end(this);
    }
}
