/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class ForVarControlRestNode extends SyntaxNode {

    private ForVariableDeclaratorsRestNode forVarDecRest = null;
    private ExpressionNode expression = null;
    private ForUpdateNode forUpdate = null;
    private boolean hasDoublePoint = false;

    public ForVarControlRestNode(Symbol s, ForVariableDeclaratorsRestNode forVarDecRest) {
        super(s);
        this.forVarDecRest = forVarDecRest;
    }

    public ForVarControlRestNode(Symbol s, ForVariableDeclaratorsRestNode forVarDecRest,
            ExpressionNode expression, ForUpdateNode forUpdate) {
        super(s);
        this.forVarDecRest = forVarDecRest;
        this.expression = expression;
        this.forUpdate = forUpdate;
    }

    public ForVarControlRestNode(Symbol s, ForVariableDeclaratorsRestNode forVarDecRest,
            ExpressionNode expression) {
        super(s);
        this.forVarDecRest = forVarDecRest;
        this.expression = expression;
    }

    public ForVarControlRestNode(Symbol s, ForVariableDeclaratorsRestNode forVarDecRest,
            ForUpdateNode forUpdate) {
        super(s);
        this.forVarDecRest = forVarDecRest;
        this.forUpdate = forUpdate;
    }

    public ForVarControlRestNode(Symbol s, ExpressionNode expression) {
        super(s);
        this.expression = expression;
        this.hasDoublePoint = true;
    }

    public boolean hasDoublePoint() {
        return this.hasDoublePoint;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.forVarDecRest, v);
        checkNull(this.forUpdate, v);
        checkNull(this.expression, v);
        visitor.end(this);
    }
}
