/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import datastructs.Pair;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class FormalParametersNode extends SyntaxNode {

    private FormalParameterDeclsNode formaleParameterDecls = null;
    private List<Pair<Type, String>> formalParameters;

    public List<Pair<Type, String>> getFormalParameters() {
        return formalParameters;
    }

    public FormalParametersNode(Symbol s, FormalParameterDeclsNode formaleParameterDecls) {
        super(s);
        this.formaleParameterDecls = formaleParameterDecls;
    }

    public FormalParametersNode(Symbol s) {
        super(s);
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.formaleParameterDecls, v);
        visitor.end(this);
    }

    public void setFormalParameters(List<Pair<Type, String>> fieldContainer) {
        this.formalParameters = fieldContainer;
    }
}
