/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class IfStatementNode extends SyntaxNode {

    private ParExpressionNode parExpression;
    private BlockNode block;
    private BlockNode elseBlock = null;

    public IfStatementNode(Symbol s, ParExpressionNode parExpression, BlockNode block) {
        super(s);
        this.parExpression = parExpression;
        this.block = block;
    }

    public IfStatementNode(Symbol s, ParExpressionNode parExpression, BlockNode block,
            BlockNode elseBlock) {
        super(s);
        this.parExpression = parExpression;
        this.block = block;
        this.elseBlock = elseBlock;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.parExpression, v);
        checkNull(this.block, v);
        checkNull(this.elseBlock, v);
        visitor.end(this);
    }
}
