/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class InterfaceGenericMethodDeclNode extends SyntaxNode {

    private TypeParametersNode typeParameters;
    private TypeNode typeNode = null;
    private boolean isVoid = false;
    private String identifier;
    private InterfaceMethodDeclaratorRestNode interfaceMethodDeclRest;

    public InterfaceGenericMethodDeclNode(Symbol s, TypeParametersNode typeParameters,
            TypeNode typeNode, String identifier,
            InterfaceMethodDeclaratorRestNode interfaceMethodDeclRest) {
        super(s);
        this.typeParameters = typeParameters;
        this.typeNode = typeNode;
        this.identifier = identifier;
        this.interfaceMethodDeclRest = interfaceMethodDeclRest;
    }

    public InterfaceGenericMethodDeclNode(Symbol s, TypeParametersNode typeParameters,
            boolean isVoid, String identifier,
            InterfaceMethodDeclaratorRestNode interfaceMethodDeclRest) {
        super(s);
        this.typeParameters = typeParameters;
        this.isVoid = isVoid;
        this.identifier = identifier;
        this.interfaceMethodDeclRest = interfaceMethodDeclRest;
    }

    public boolean isVoid() {
        return this.isVoid;
    }

    public String getIdentifier() {
        return this.identifier;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.typeParameters, v);
        checkNull(this.typeNode, v);
        checkNull(this.interfaceMethodDeclRest, v);
        visitor.end(this);
    }
}
