/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class LiteralNode extends SyntaxNode {
    //EDIT

    public enum LiteralType {

        BOOLEAN,
        INT,
        LONG,
        FLOAT,
        DOUBLE,
        CHAR,
        STRING,
        NULL;
    }
    private String value;
    private LiteralType type;

    public LiteralNode(Symbol s, LiteralType type, String value) {
        super(s);
        this.type = type;
        this.value = value;
    }
    //TODO type to string

    public LiteralType getLiteralType() {
        return this.type;
    }

    public String getLiteralValue() {
        return value;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        visitor.visit(this);
        visitor.end(this);
    }
}
