/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
public class QualifiedIdentifierNode extends SyntaxNode {

    private ArrayList<IdentifierNode> identifiers;
    private final boolean isNull;

    public QualifiedIdentifierNode(ArrayList<IdentifierNode> identifiers) {
        super(identifiers.get(0).getSymbol());
        this.identifiers = identifiers;
        this.isNull = false;
    }
    /*
     * MAKE null IDENTIFIER
     */

    public QualifiedIdentifierNode(Symbol s) {
        super(s);
        this.isNull = true;
    }

    public boolean isNullIdentifier() {
        return this.isNull;
    }
    
    public List<IdentifierNode> getList() {
        return identifiers;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.identifiers, v);
        visitor.end(this);
    }
}
