/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class SwitchLabelNode extends SyntaxNode {

    private ExpressionNode expressionCase = null;
    private EnumConstantNameNode enumConstantNameCase = null;
    private boolean isDefault = false;

    public SwitchLabelNode(Symbol s, boolean isDefault) {
        super(s);
        this.isDefault = isDefault;
    }

    public SwitchLabelNode(Symbol s, ExpressionNode expressionCase) {
        super(s);
        this.expressionCase = expressionCase;
    }

    public boolean isDefault() {
        return this.isDefault;
    }

    public SwitchLabelNode(Symbol s, EnumConstantNameNode enumConstantNameCase) {
        super(s);
        this.enumConstantNameCase = enumConstantNameCase;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.expressionCase, v);
        checkNull(this.enumConstantNameCase, v);
        visitor.end(this);
    }
}
