/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class TjTypeDefMemberDeclNode extends SyntaxNode {

    private String ident;
    private TypeNode type;
    private InterfaceMethodDeclaratorRestNode methodDeclRest;
    private TjTypeDefConstructorDeclNode constructorDecl;
    private InterfaceGenericMethodDeclNode genericMethodDecl;
    private VoidInterfaceMethodDeclaratorRestNode voidMethodDecl;

    public TjTypeDefMemberDeclNode(Symbol s, TypeNode type, String ident,
            InterfaceMethodDeclaratorRestNode interfaceMethodDeclaratorRest) {
        super(s);
        this.type = type;
        this.ident = ident;
        this.methodDeclRest = interfaceMethodDeclaratorRest;
    }

    public TjTypeDefMemberDeclNode(Symbol s, TjTypeDefConstructorDeclNode constructorDecl) {
        super(s);
        this.constructorDecl = constructorDecl;
    }

    public TjTypeDefMemberDeclNode(Symbol s, String ident, VoidInterfaceMethodDeclaratorRestNode voidInterfaceMethodDeclaratorRestNode) {
        super(s);
        this.ident = ident;
        this.voidMethodDecl = voidInterfaceMethodDeclaratorRestNode;
    }

    public TjTypeDefMemberDeclNode(Symbol s, InterfaceGenericMethodDeclNode genericMethodDecl) {
        super(s);
        this.genericMethodDecl = genericMethodDecl;
    }

    public String getIdentifier() {
        return this.ident;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.constructorDecl, v);
        checkNull(this.type, v);
        checkNull(this.methodDeclRest, v);
        checkNull(this.voidMethodDecl, v);
        checkNull(this.genericMethodDecl, v);
        visitor.end(this);
    }
}
