/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import exceptions.CompilerException;
import lexer.Symbol;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public class VariableModifierNode extends SyntaxNode {

    private boolean isFinal = false;
    private AnnotationNode annotation = null;
    private Symbol sym;

    public VariableModifierNode(Symbol s, boolean isFinal) {
        super(s);
        this.sym = s;
        this.isFinal = isFinal;
    }

    public VariableModifierNode(AnnotationNode annotation) {
        this.annotation = annotation;
    }

    public boolean isFinal() {
        return this.isFinal;
    }

    public boolean isAnnotation() {
        return this.annotation != null;
    }

    public Symbol getSymbol() {
        return sym;
    }

    public AnnotationNode getAnnotationNode() {
        return this.annotation;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.annotation, v);
        visitor.end(this);
    }
}
