/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration;

import abstractsyntaxtree.*;
import abstractsyntaxtree.BasicTypeNode.BasicType;
import abstractsyntaxtree.InfixOpNode.InfixOps;
import abstractsyntaxtree.ModifierNode.Modifier;
import abstractsyntaxtree.PostfixOpNode.PostfixOps;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import teajay.bytecode.*;
import teajay.bytecode.attributes.code.ALoad;
import teajay.bytecode.attributes.code.AppendFrame;
import teajay.bytecode.attributes.code.IConst;
import teajay.bytecode.attributes.code.IInc;
import teajay.bytecode.attributes.code.ILoad;
import teajay.bytecode.attributes.code.IMode;
import teajay.bytecode.attributes.code.IStore;
import teajay.bytecode.attributes.code.IfICmp;
import teajay.bytecode.attributes.code.JVMInstruction;
import teajay.bytecode.attributes.code.JVMInstructionList;
import teajay.bytecode.attributes.code.Label;
import teajay.bytecode.attributes.code.Ldc;
import teajay.bytecode.attributes.code.NOP;
import teajay.bytecode.attributes.code.Return;
import teajay.bytecode.attributes.code.StackMapTable;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.IntegerInfo;
import teajay.bytecode.cpool.MethodDescriptor;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.exceptions.MalformedClassNameException;
import teajay.bytecode.methods.MethodAccessFlag;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author Michael Burzan
 */
public class JavaVisitor extends Visitor {
//   private ClassFile classFile;
//    private String packageName;
//    private List<String> qIdentifier = new LinkedList<>();
//    private ArrayList<ClassAccessFlag> accessFlags = new ArrayList<>();
//    private boolean actuallyAcceptClass;
//    private ArrayList<MethodAccessFlag> methodAccessFlags = new ArrayList<>();
//    private String methodName;
//    private int arrayDim;
//    private String typeName;
//    private String varName;
//    private FieldDescriptor fieldDescriptor;
//    private MethodInfo info;
//    private JVMInstructionList instructionList;
//    private boolean isLocalVariablDeclStatement = false;
//    private FieldDescriptor localVarDef;
//    private int val;
//    private Label doLabel;
//    private Integer varNameStatementIndex;
//    private InfixOps infixOperator;
//    
//    private static class LocalVariableTable{
//        private HashMap<String,Integer> table = new HashMap<>();
//        private int index = 0;
//        public LocalVariableTable(){ }
//        
//        public void add(String name){
//            this.table.put(name, this.index++);
//        }
//        
//        public void rename(String oldName, String newName){
//            Integer i = this.table.get(oldName);
//            if(i == null){
//                //TODO error 
//            }
//            this.table.put(newName, i);
//        }
//        public Integer getIndexByName(String name){
//            return this.table.get(name);
//        }
//        
//    }
//    private LocalVariableTable localVarTable = new LocalVariableTable();
//    
//    
//    
//    @Override
//    public void visit(BasicTypeNode node) {
//        BasicType type = node.getType();
//        try {
//            this.localVarDef = FieldDescriptor.fromString(type.toString());
//        } catch (MalformedClassNameException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (ByteCodeException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//        
//    }
//
//    @Override
//    public void visit(BlockNode node) {
//        //MethodInfo info;
//        try {
//            if(this.info == null){
//            this.info = new MethodInfo(this.methodName, 
//                          new MethodDescriptor(FieldDescriptor.getVoid(),
//                              this.fieldDescriptor), classFile.getThis(),
//                              this.methodAccessFlags.toArray(new MethodAccessFlag[0]));
//                  
//            this.classFile.addMethod(info);
//            this.instructionList = this.info.getCode().getInstructionList();
//           }
//        } catch (ByteCodeException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//            
//    }
//
//
//    @Override
//    public void visit(ClassOrInterfaceDeclaratioNode node) {
//        this.actuallyAcceptClass = true;
//    }
//
//    @Override
//    public void visit(DoStatementNode node) {
//        this.doLabel = new Label();
//        try {
//            JVMInstruction nop = this.instructionList.add(doLabel,new NOP());
//            StackMapTable stackMapTable = info.getCode().getStackMapTable();
//            AppendFrame frame = stackMapTable.addAppendFrame(nop);
//            frame.addLocalInteger();
//            frame.addLocalInteger();
//        } catch (ByteCodeException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }
//
//    @Override
//    public void visit(IdentifierNode node) {
//        qIdentifier.add(node.getName());
//    }
//
//
//    @Override
//    public void visit(InfixOpNode node) {
//        this.infixOperator = node.getOperator();
//    }
//
//
//    @Override
//    public void visit(LiteralNode node) {
//        this.val = node.getIntVal();
//    }
//
//    @Override
//    public void visit(LocalVariableDeclarationsStatementNode node) {
//        this.isLocalVariablDeclStatement = true;
//    }
//
//    @Override
//    public void visit(ModifierNode node) {
//        Modifier m = node.getModifier();
//        if(actuallyAcceptClass){
//            ClassAccessFlag accessFlag = ClassAccessFlag.PACKAGE_PRIVATE; 
//            switch(m){
//                case ABSTRACT:
//                        accessFlag = ClassAccessFlag.ABSTRACT;
//                        break;
//                case FINAL:
//                        accessFlag = ClassAccessFlag.FINAL;
//                        break;
//                case PUBLIC:
//                        accessFlag = ClassAccessFlag.PUBLIC;
//                        break;
//                default:
//                   // System.err.println("LECK MICH!"); // TODO ENTFERNEN
//            }
//            this.accessFlags.add(accessFlag);
//            this.actuallyAcceptClass = false;
//        }
//        else{
//            MethodAccessFlag mAccessFlags = MethodAccessFlag.PACKAGE_PRIVATE;
//            switch(m){
//                case ABSTRACT:
//                        mAccessFlags = MethodAccessFlag.ABSTRACT;
//                        break;
//                case FINAL:
//                        mAccessFlags = MethodAccessFlag.FINAL;
//                        break;
//                case STATIC:
//                        mAccessFlags = MethodAccessFlag.STATIC;
//                        break;
//                case SYNCHRONIZED:
//                        mAccessFlags = MethodAccessFlag.SYNCHRONIZED;
//                        break;
//                case PUBLIC:
//                        mAccessFlags = MethodAccessFlag.PUBLIC;
//                        break;
//                case PROTECTED:
//                        mAccessFlags = MethodAccessFlag.PROTECTED;
//                        break;
//                case PRIVATE:
//                        mAccessFlags = MethodAccessFlag.PRIVATE;
//                        break;
//                case NATIVE:
//                        mAccessFlags = MethodAccessFlag.NATIVE;
//                        break;
//                case STRICTFP:
//                        mAccessFlags = MethodAccessFlag.STRICT;
//                        break;
//                default:
//            }
//            this.methodAccessFlags.add(mAccessFlags);
//        }
//        
//    }
//
//    @Override
//    public void visit(NormalClassDeclarationNode node) {
//        try{
//            String className = node.getClassName();
//            this.classFile = new ClassFile(packageName+"/"+className, this.accessFlags.toArray(new ClassAccessFlag[0]));
//        }
//        catch(ByteCodeException exception){
//            exception.printStackTrace();
//        }
//    }
//
//    @Override
//    public void visit(PostfixOpNode node) {
//        
//        PostfixOps operator = node.getOperator();
//        try{
//          
//            if(operator == PostfixOps.ADD_ADD){
//                this.instructionList.add(new IInc(this.varNameStatementIndex, 1));
//            }else{
//                this.instructionList.add(new IInc(this.varNameStatementIndex, -1));
//            }
//        }catch (ByteCodeException ex){
//            
//        }
//    }
//
//    @Override
//    public void visit(PrimaryNode node) {
//        if(node.getIdentifier() != null){
//            String name = node.getIdentifier();
//            this.varNameStatementIndex = this.localVarTable.getIndexByName(name);
//         
//        }
//    }
//
//    @Override
//    public void visit(ReferenceTypeNode node) {
//        this.typeName = node.getName();
//        if(typeName.equals("String")){
//            this.typeName = "java/lang/String";
//        }
//    }
//
//
//    @Override
//    public void visit(VariableDeclaratorIdNode node) {
//        this.varName = node.getName();
//    }
//
//    @Override
//    public void visit(VariableDeclaratorNode node) {
//        this.varName = node.getName();
//    }
//
//    @Override
//    public void visit(VoidMethodeDeclaratorRestHelperNode node) {
//        this.methodName = node.getMethodName();
//    }
//
//    @Override
//    public void end(CompilationUnitHelperNode aThis) {
//        StringBuilder builder = new StringBuilder();
//        Iterator<String> iter = qIdentifier.iterator();
//        while(iter.hasNext()){
//            builder.append(iter.next());
//            if(iter.hasNext()){
//                builder.append("/");
//            }
//        }
//        this.packageName = builder.toString();
//        qIdentifier.clear();
//    }
//
//    @Override
//    public void end(CompilationUnitNode node) {
//        String className = this.classFile.getThis().getClassName();
//        String[] split = className.split("/");
//        try {
//            DataOutputStream out = new DataOutputStream(new FileOutputStream(split[split.length-1]+".class"));
//            try {
//                classFile.write(out);
//                out.close();
//            } catch (IOException ex) {
//                Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//            } catch (ByteCodeException ex) {
//                Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//            }
//        }
//        catch (FileNotFoundException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }
//
//    @Override
//    public void end(VoidMethodeDeclaratorRestHelperNode node) {
//           /* MethodInfo info = new MethodInfo(this.methodName, 
//                                 new MethodDescriptor(FieldDescriptor.getVoid(), 
//                                     this.fieldDescriptor), classFile.getThis(),
//                                     this.methodAccessFlags.toArray(new MethodAccessFlag[0]));
//            this.classFile.addMethod(info);*/
//            this.info.getCode().getInstructionList().add(new Return());
//            
//       
//    }
//
//    @Override
//    public void end(TypeNode node) {
//       this.arrayDim = node.getArrayDim();
//    }
//    
//    @Override
//    public void end(FormalParametersNode node) {
//        try {
//            //TODO WRITE
//            this.fieldDescriptor = FieldDescriptor.makeArray(FieldDescriptor.fromString(this.typeName), this.arrayDim);
//            this.localVarTable.add(this.varName);
//        } catch (MalformedClassNameException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (ByteCodeException ex) {
//            Logger.getLogger(JavaVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }
//   
//    @Override
//    public void end(LocalVariableDeclarationsStatementNode node){
//        try{
//            this.localVarTable.add(varName);
//            if(this.val >= Short.MIN_VALUE && this.val <= Short.MAX_VALUE){
//                this.instructionList.add(new IConst(this.val));
//            }else{
//                this.instructionList.add(new Ldc(new IntegerInfo(val)));
//            }
//            this.instructionList.add(new IStore(this.localVarTable.getIndexByName(varName)));
//            this.isLocalVariablDeclStatement = false; // reset 
//        }catch(ByteCodeException ex){
//            
//        }
//    }
//    
//    @Override      
//    public void end(Expression2RestNode exp2RestNode){
//        //TODO check Type
//        try{
//            this.instructionList.add(new ILoad(this.varNameStatementIndex));
//            this.instructionList.add(new IConst(this.val));
//      
//            if(this.infixOperator == InfixOps.LESS){
//                this.instructionList.add(new IfICmp(IMode.lt,this.doLabel));
//                StackMapTable table = info.getCode().getStackMapTable();
//                
//                table.addSameFrame(this.instructionList.add(new NOP()));
//            }
//        }
//       catch(ByteCodeException e){
//           
//       }
//    }
}
