/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration;

import abstractsyntaxtree.*;
import abstractsyntaxtree.CreatedNameNode.IdentTypeArgumentsOrDiamondNode;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public abstract class Visitor {

    public void begin(AnnotationElementNode node) throws CompilerException {
    }

    public void begin(AnnotationMethodOrConstantRestNode node) throws CompilerException {
    }

    public void begin(AnnotationMethodRestNode node) throws CompilerException {
    }

    public void begin(AnnotationNode node) throws CompilerException {
    }

    public void begin(AnnotationsNode node) throws CompilerException {
    }

    public void begin(AnnotationTypeBodyNode node) throws CompilerException {
    }

    public void begin(AnnotationTypeDeclarationNode node) throws CompilerException {
    }

    public void begin(AnnotationTypeElementDeclarationNode node) throws CompilerException {
    }

    public void begin(AnnotationTypeElementDeclarationsNode node) throws CompilerException {
    }

    public void begin(AnnotationTypeElementRestNode node) throws CompilerException {
    }

    public void begin(ArgumentsNode node) throws CompilerException {
    }

    public void begin(ArrayCreatorRestNode node) throws CompilerException {
    }

    public void begin(ArrayInitializerNode node) throws CompilerException {
    }

    public void begin(AssertStatementNode node) throws CompilerException {
    }

    public void begin(AssignmentOperatorNode node) throws CompilerException {
    }

    public void begin(BasicTypeNode node) throws CompilerException {
    }

    public void begin(BlockNode node) throws CompilerException {
    }

    public void begin(BlockStatementNode node) throws CompilerException {
    }

    public void begin(BlockStatementsNode node) throws CompilerException {
    }

    public void begin(BoundNode node) throws CompilerException {
    }

    public void begin(BreakStatementNode node) throws CompilerException {
    }

    public void begin(CatchClauseNode node) throws CompilerException {
    }

    public void begin(CatchesNode node) throws CompilerException {
    }

    public void begin(CatchTypeNode node) throws CompilerException {
    }

    public void begin(ClassBodyDeclarationNode node) throws CompilerException {
    }

    public void begin(ClassBodyNode node) throws CompilerException {
    }

    public void begin(ClassCreatorRestNode node) throws CompilerException {
    }

    public void begin(ClassDeclarationNode node) throws CompilerException {
    }

    public void begin(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
    }

    public void begin(CompilationUnitHelperNode node) throws CompilerException {
    }

    public void begin(CompilationUnitNode node) throws CompilerException {
    }

    public void begin(ConstantDeclaratorNode node) throws CompilerException {
    }

    public void begin(ConstantDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(ConstantDeclaratorsRestNode node) throws CompilerException {
    }

    public void begin(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void begin(ConstructorDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(ContinueStatementNode node) throws CompilerException {
    }

    public void begin(CreatedNameNode node) throws CompilerException {
    }

    public void begin(CreatorNode node) throws CompilerException {
    }

    public void begin(DoStatementNode node) throws CompilerException {
    }

    public void begin(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
    }

    public void begin(EdgeClampsOpenCloseHelperNode node) throws CompilerException {
    }

    public void begin(ElementValueArrayInitializerNode node) throws CompilerException {
    }

    public void begin(ElementValueNode node) throws CompilerException {
    }

    public void begin(ElementValuePairNode node) throws CompilerException {
    }

    public void begin(ElementValuePairsNode node) throws CompilerException {
    }

    public void begin(ElementValuesNode node) throws CompilerException {
    }

    public void begin(EnumBodyDeclarationsNode node) throws CompilerException {
    }

    public void begin(EnumBodyNode node) throws CompilerException {
    }

    public void begin(EnumConstantNameNode node) throws CompilerException {
    }

    public void begin(EnumConstantNode node) throws CompilerException {
    }

    public void begin(EnumConstantsNode node) throws CompilerException {
    }

    public void begin(EnumDeclarationNode node) throws CompilerException {
    }

    public void begin(Et1Node node) throws CompilerException {
    }

    public void begin(ExplicitGenericInvocationNode node) throws CompilerException {
    }

    public void begin(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
    }

    public void begin(Expression1Node node) throws CompilerException {
    }

    public void begin(Expression1RestNode node) throws CompilerException {
    }

    public void begin(Expression2Node node) throws CompilerException {
    }

    public void begin(Expression2RestNode node) throws CompilerException {
    }

    public void begin(Expression3Node node) throws CompilerException {
    }

    public void begin(ExpressionHelperNode node) throws CompilerException {
    }

    public void begin(ExpressionNode node) throws CompilerException {
    }

    public void begin(FieldDeclaratorsRestNode node) throws CompilerException {
    }

    public void begin(FinallyNode node) throws CompilerException {
    }

    public void begin(ForControlNode node) throws CompilerException {
    }

    public void begin(ForInitNode node) throws CompilerException {
    }

    public void begin(FormalParameterDeclsNode node) throws CompilerException {
    }

    public void begin(FormalParameterDeclsRestNode node) throws CompilerException {
    }

    public void begin(FormalParametersNode node) throws CompilerException {
    }

    public void begin(ForStatementNode node) throws CompilerException {
    }

    public void begin(ForUpdateNode node) throws CompilerException {
    }

    public void begin(ForVarControlNode node) throws CompilerException {
    }

    public void begin(ForVarControlRestNode node) throws CompilerException {
    }

    public void begin(ForVariableDeclaratorsRestNode node) throws CompilerException {
    }

    public void begin(GenericConstructorDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void begin(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
    }

    public void begin(GenericMethodeOrConstructorHelperNode node) throws CompilerException {
    }

    public void begin(GenericMethodeOrConstructorRestNode node) throws CompilerException {
    }

    public void begin(IdentDoublePointStatementNode node) throws CompilerException {
    }

    public void begin(IdentifierNode node) throws CompilerException {
    }

    public void begin(IdentifierSuffixNode node) throws CompilerException {
    }

    public void begin(IfStatementNode node) throws CompilerException {
    }

    public void begin(ImportDeclarationNode node) throws CompilerException {
    }

    public void begin(InfixOpNode node) throws CompilerException {
    }

    public void begin(InnerCreatorNode node) throws CompilerException {
    }

    public void begin(InterfaceBodyDeclarationNode node) throws CompilerException {
    }

    public void begin(InterfaceBodyNode node) throws CompilerException {
    }

    public void begin(InterfaceDeclarationNode node) throws CompilerException {
    }

    public void begin(InterfaceGenericMethodDeclNode node) throws CompilerException {
    }

    public void begin(InterfaceMemberDeclNode node) throws CompilerException {
    }

    public void begin(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(InterfaceMethodOrFieldDeclNode node) throws CompilerException {
    }

    public void begin(InterfaceMethodOrFieldRestNode node) throws CompilerException {
    }

    public void begin(LiteralNode node) throws CompilerException {
    }

    public void begin(LocalVariableDeclarationsStatementNode node) throws CompilerException {
    }

    public void begin(MemberDeclNode node) throws CompilerException {
    }

    public void begin(MethodeDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(MethodeOrFieldDeclNode node) throws CompilerException {
    }

    public void begin(MethodeOrFieldRestNode node) throws CompilerException {
    }

    public void begin(ModifierNode node) throws CompilerException {
    }

    public void begin(NonWildcardTypeArgumentsNode node) throws CompilerException {
    }

    public void begin(NonWildcardTypeArgumentsOrDiamond node) throws CompilerException {
    }

    public void begin(NormalClassDeclarationNode node) throws CompilerException {
    }

    public void begin(NormalInterfaceDeclarationNode node) throws CompilerException {
    }

    public void begin(ParExpressionNode node) throws CompilerException {
    }

    public void begin(PostfixOpNode node) throws CompilerException {
    }

    public void begin(PrefixOpNode node) throws CompilerException {
    }

    public void begin(PrimaryNode node) throws CompilerException {
    }

    public void begin(QualifiedIdentifierListNode node) throws CompilerException {
    }

    public void begin(QualifiedIdentifierNode node) throws CompilerException {
    }

    public void begin(ReferenceTypeNode node) throws CompilerException {
    }

    public void begin(ResourceNode node) throws CompilerException {
    }

    public void begin(ResourcesNode node) throws CompilerException {
    }

    public void begin(ResourceSpecificationNode node) throws CompilerException {
    }

    public void begin(ReturnStatementNode node) throws CompilerException {
    }

    public void begin(SelectorNode node) throws CompilerException {
    }

    public void begin(StatementExpressionNode node) throws CompilerException {
    }

    public void begin(StatementNode node) throws CompilerException {
    }

    public void begin(SuperSuffixNode node) throws CompilerException {
    }

    public void begin(SwitchBlockStatementGroupNode node) throws CompilerException {
    }

    public void begin(SwitchBlockStatementGroupsNode node) throws CompilerException {
    }

    public void begin(SwitchLabelNode node) throws CompilerException {
    }

    public void begin(SwitchLabelsNode node) throws CompilerException {
    }

    public void begin(SwitchStatementNode node) throws CompilerException {
    }

    public void begin(SynchronizedStatementNode node) throws CompilerException {
    }

    public void begin(ThrowStatementNode node) throws CompilerException {
    }

    public void begin(TryStatementNode node) throws CompilerException {
    }

    public void begin(TypeArgumentNode node) throws CompilerException {
    }

    public void begin(TypeArgumentsListHelperNode node) throws CompilerException {
    }

    public void begin(TypeArgumentsNode node) throws CompilerException {
    }

    public void begin(TypeArgumentsOrDiamondNode node) throws CompilerException {
    }

    public void begin(TypeDeclarationNode node) throws CompilerException {
    }

    public void begin(TypeListNode node) throws CompilerException {
    }

    public void begin(TypeNode node) throws CompilerException {
    }

    public void begin(TypeParameterNode node) throws CompilerException {
    }

    public void begin(TypeParametersNode node) throws CompilerException {
    }

    public void begin(VariableDeclaratorIdNode node) throws CompilerException {
    }

    public void begin(VariableDeclaratorNode node) throws CompilerException {
    }

    public void begin(VariableDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(VariableDeclaratorsNode node) throws CompilerException {
    }

    public void begin(VariableInitializerNode node) throws CompilerException {
    }

    public void begin(VariableModifierNode node) throws CompilerException {
    }

    public void begin(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void begin(VoidMethodeDeclaratorRestNode node) throws CompilerException {
    }

    public void begin(WhileStatementNode node) throws CompilerException {
    }
    
    public void begin(IdentTypeArgumentsOrDiamondNode node ) throws CompilerException{
    }
    
    /*TeaJay*/

    public void begin(TypeSwitchStatementNode node) throws CompilerException {
    }

    public void begin(TypeSwitchBlocksNode node) throws CompilerException {
    }

    public void begin(TypeSwitchBlockNode node) throws CompilerException {
    }

    public void begin(TypeSwitchLabelNode node) throws CompilerException {
    }

    public void begin(ClosureTypeDecNode node) throws CompilerException {
    }

    public void begin(ClosureTypeFormalParamNode node) throws CompilerException {
    }

    public void begin(ClosureCreatorNode node) throws CompilerException {
    }

    public void begin(ClosureReturnNode node) throws CompilerException {
    }

    public void begin(ClosureEnvNode node) throws CompilerException {
    }

    public void begin(ClosureEnvListNode node) throws CompilerException {
    }

    public void begin(ClosureEnvItemNode node) throws CompilerException {
    }

    public void begin(TjTypeDefNode node) throws CompilerException {
    }

    public void begin(TjTypeDefMemberDeclNode node) throws CompilerException {
    }

    public void begin(TjTypeDefConstructorDeclNode node) throws CompilerException {
    }

    public void begin(TjTypeDefBodyNode node) throws CompilerException {
    }

    public void begin(TjTypeDefBodyDeclarationNode node) throws CompilerException{
    }

    public void begin(TjImplDeclarationNode node) throws CompilerException {
    }

    public Visitor visit(AnnotationElementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationMethodOrConstantRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationMethodRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationTypeBodyNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationTypeDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationTypeElementDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationTypeElementDeclarationsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AnnotationTypeElementRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ArgumentsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ArrayCreatorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ArrayInitializerNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(AssertStatementNode node) throws CompilerException {
        return this;
    }

    public void visit(AssignmentOperatorNode node) throws CompilerException {
    }

    public void visit(BasicTypeNode node) throws CompilerException {
    }

    public Visitor visit(BlockNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(BlockStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(BlockStatementsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(BoundNode node) throws CompilerException {
        return this;
    }

    public void visit(BreakStatementNode node) throws CompilerException {
    }

    public Visitor visit(CatchClauseNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(CatchesNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(CatchTypeNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClassBodyDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClassBodyNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClassCreatorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClassDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(CompilationUnitHelperNode node) throws CompilerException {
        return this;
    }

    public void visit(CompilationUnitNode node) throws CompilerException {
    }

    public Visitor visit(ConstantDeclaratorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ConstantDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ConstantDeclaratorsRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ConstructorDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public void visit(ContinueStatementNode node) throws CompilerException {
    }

    public Visitor visit(CreatedNameNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(CreatorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(DoStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
        return this;
    }

    public void visit(EdgeClampsOpenCloseHelperNode node) throws CompilerException {
    }

    public Visitor visit(ElementValueArrayInitializerNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ElementValueNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ElementValuePairNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ElementValuePairsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ElementValuesNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(EnumBodyDeclarationsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(EnumBodyNode node) throws CompilerException {
        return this;
    }

    public void visit(EnumConstantNameNode node) throws CompilerException {
    }

    public Visitor visit(EnumConstantNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(EnumConstantsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(EnumDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(Et1Node node) throws CompilerException {
        return this;
    }

    public Visitor visit(ExplicitGenericInvocationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(Expression1Node node) throws CompilerException {
        return this;
    }

    public Visitor visit(Expression1RestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(Expression2Node node) throws CompilerException {
        return this;
    }

    public Visitor visit(Expression2RestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(Expression3Node node) throws CompilerException {
        return this;
    }

    public Visitor visit(ExpressionHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ExpressionNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(FieldDeclaratorsRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(FinallyNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForControlNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForInitNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(FormalParameterDeclsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(FormalParameterDeclsRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(FormalParametersNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForUpdateNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForVarControlNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForVarControlRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ForVariableDeclaratorsRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(GenericConstructorDeclaratorRestHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(GenericMethodeOrConstructorHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(IdentDoublePointStatementNode node) throws CompilerException {
        return this;
    }

    public void visit(IdentifierNode node) throws CompilerException {
    }

    public Visitor visit(IdentifierSuffixNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(IfStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ImportDeclarationNode node) throws CompilerException {
        return this;
    }

    public void visit(InfixOpNode node) throws CompilerException {
    }

    public Visitor visit(InnerCreatorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceBodyDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceBodyNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceGenericMethodDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceMemberDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceMethodOrFieldDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(InterfaceMethodOrFieldRestNode node) throws CompilerException {
        return this;
    }

    public void visit(LiteralNode node) throws CompilerException {
    }

    public Visitor visit(LocalVariableDeclarationsStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(MemberDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(MethodeDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(MethodeOrFieldDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(MethodeOrFieldRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ModifierNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(NonWildcardTypeArgumentsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(NonWildcardTypeArgumentsOrDiamond node) throws CompilerException {
        return this;
    }

    public Visitor visit(NormalClassDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(NormalInterfaceDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ParExpressionNode node) throws CompilerException {
        return this;
    }

    public void visit(PostfixOpNode node) throws CompilerException {
    }

    public void visit(PrefixOpNode node) throws CompilerException {
    }

    public Visitor visit(PrimaryNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(QualifiedIdentifierListNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(QualifiedIdentifierNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ReferenceTypeNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ResourceNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ResourcesNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ResourceSpecificationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ReturnStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SelectorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(StatementExpressionNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(StatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SuperSuffixNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SwitchBlockStatementGroupNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SwitchBlockStatementGroupsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SwitchLabelNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SwitchLabelsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SwitchStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(SynchronizedStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ThrowStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TryStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeArgumentNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeArgumentsListHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeArgumentsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeArgumentsOrDiamondNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeListNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeParameterNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeParametersNode node) throws CompilerException {
        return this;
    }

    public void visit(VariableDeclaratorIdNode node) throws CompilerException {
    }

    public Visitor visit(VariableDeclaratorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VariableDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VariableDeclaratorsNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VariableInitializerNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VariableModifierNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(VoidMethodeDeclaratorRestNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(WhileStatementNode node) throws CompilerException {
        return this;
    }
    public Visitor visit(IdentTypeArgumentsOrDiamondNode node ) throws CompilerException{
        return this;
    }
    /*TeaJay*/

    public Visitor visit(TypeSwitchStatementNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeSwitchBlocksNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeSwitchBlockNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TypeSwitchLabelNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureTypeDecNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureTypeFormalParamNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureCreatorNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureReturnNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureEnvNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureEnvListNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(ClosureEnvItemNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjTypeDefNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjTypeDefMemberDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjTypeDefConstructorDeclNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjTypeDefBodyNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjTypeDefBodyDeclarationNode node) throws CompilerException {
        return this;
    }

    public Visitor visit(TjImplDeclarationNode node) throws CompilerException {
        return this;
    }

    public void end(AnnotationElementNode node) throws CompilerException {
    }

    public void end(AnnotationMethodOrConstantRestNode node) throws CompilerException {
    }

    public void end(AnnotationMethodRestNode node) throws CompilerException {
    }

    public void end(AnnotationNode node) throws CompilerException {
    }

    public void end(AnnotationsNode node) throws CompilerException {
    }

    public void end(AnnotationTypeBodyNode node) throws CompilerException {
    }

    public void end(AnnotationTypeDeclarationNode node) throws CompilerException {
    }

    public void end(AnnotationTypeElementDeclarationNode node) throws CompilerException {
    }

    public void end(AnnotationTypeElementDeclarationsNode node) throws CompilerException {
    }

    public void end(AnnotationTypeElementRestNode node) throws CompilerException {
    }

    public void end(ArgumentsNode node) throws CompilerException {
    }

    public void end(ArrayCreatorRestNode node) throws CompilerException {
    }

    public void end(ArrayInitializerNode node) throws CompilerException {
    }

    public void end(AssertStatementNode node) throws CompilerException {
    }

    public void end(AssignmentOperatorNode node) throws CompilerException {
    }

    public void end(BasicTypeNode node) throws CompilerException {
    }

    public void end(BlockNode node) throws CompilerException {
    }

    public void end(BlockStatementNode node) throws CompilerException {
    }

    public void end(BlockStatementsNode node) throws CompilerException {
    }

    public void end(BoundNode node) throws CompilerException {
    }

    public void end(BreakStatementNode node) throws CompilerException {
    }

    public void end(CatchClauseNode node) throws CompilerException {
    }

    public void end(CatchesNode node) throws CompilerException {
    }

    public void end(CatchTypeNode node) throws CompilerException {
    }

    public void end(ClassBodyDeclarationNode node) throws CompilerException {
    }

    public void end(ClassBodyNode node) throws CompilerException {
    }

    public void end(ClassCreatorRestNode node) throws CompilerException {
    }

    public void end(ClassDeclarationNode node) throws CompilerException {
    }

    public void end(ClassOrInterfaceDeclaratioNode node) throws CompilerException {
    }

    public void end(CompilationUnitHelperNode node) throws CompilerException {
    }

    public void end(CompilationUnitNode node) throws CompilerException {
    }

    public void end(ConstantDeclaratorNode node) throws CompilerException {
    }

    public void end(ConstantDeclaratorRestNode node) throws CompilerException {
    }

    public void end(ConstantDeclaratorsRestNode node) throws CompilerException {
    }

    public void end(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void end(ConstructorDeclaratorRestNode node) throws CompilerException {
    }

    public void end(ContinueStatementNode node) throws CompilerException {
    }

    public void end(CreatedNameNode node) throws CompilerException {
    }

    public void end(CreatorNode node) throws CompilerException {
    }

    public void end(DoStatementNode node) throws CompilerException {
    }

    public void end(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
    }

    public void end(EdgeClampsOpenCloseHelperNode node) throws CompilerException {
    }

    public void end(ElementValueArrayInitializerNode node) throws CompilerException {
    }

    public void end(ElementValueNode node) throws CompilerException {
    }

    public void end(ElementValuePairNode node) throws CompilerException {
    }

    public void end(ElementValuePairsNode node) throws CompilerException {
    }

    public void end(ElementValuesNode node) throws CompilerException {
    }

    public void end(EnumBodyDeclarationsNode node) throws CompilerException {
    }

    public void end(EnumBodyNode node) throws CompilerException {
    }

    public void end(EnumConstantNameNode node) throws CompilerException {
    }

    public void end(EnumConstantNode node) throws CompilerException {
    }

    public void end(EnumConstantsNode node) throws CompilerException {
    }

    public void end(EnumDeclarationNode node) throws CompilerException {
    }

    public void end(Et1Node node) throws CompilerException {
    }

    public void end(ExplicitGenericInvocationNode node) throws CompilerException {
    }

    public void end(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
    }

    public void end(Expression1Node node) throws CompilerException {
    }

    public void end(Expression1RestNode node) throws CompilerException {
    }

    public void end(Expression2Node node) throws CompilerException {
    }

    public void end(Expression2RestNode node) throws CompilerException {
    }

    public void end(Expression3Node node) throws CompilerException {
    }

    public void end(ExpressionHelperNode node) throws CompilerException {
    }

    public void end(ExpressionNode node) throws CompilerException {
    }

    public void end(FieldDeclaratorsRestNode node) throws CompilerException {
    }

    public void end(FinallyNode node) throws CompilerException {
    }

    public void end(ForControlNode node) throws CompilerException {
    }

    public void end(ForInitNode node) throws CompilerException {
    }

    public void end(FormalParameterDeclsNode node) throws CompilerException {
    }

    public void end(FormalParameterDeclsRestNode node) throws CompilerException {
    }

    public void end(FormalParametersNode node) throws CompilerException {
    }

    public void end(ForStatementNode node) throws CompilerException {
    }

    public void end(ForUpdateNode node) throws CompilerException {
    }

    public void end(ForVarControlNode node) throws CompilerException {
    }

    public void end(ForVarControlRestNode node) throws CompilerException {
    }

    public void end(ForVariableDeclaratorsRestNode node) throws CompilerException {
    }

    public void end(GenericConstructorDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void end(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
    }

    public void end(GenericMethodeOrConstructorHelperNode node) throws CompilerException {
    }

    public void end(GenericMethodeOrConstructorRestNode node) throws CompilerException {
    }

    public void end(IdentDoublePointStatementNode node) throws CompilerException {
    }

    public void end(IdentifierNode node) throws CompilerException {
    }

    public void end(IdentifierSuffixNode node) throws CompilerException {
    }

    public void end(IfStatementNode node) throws CompilerException {
    }

    public void end(ImportDeclarationNode node) throws CompilerException {
    }

    public void end(InfixOpNode node) throws CompilerException {
    }

    public void end(InnerCreatorNode node) throws CompilerException {
    }

    public void end(InterfaceBodyDeclarationNode node) throws CompilerException {
    }

    public void end(InterfaceBodyNode node) throws CompilerException {
    }

    public void end(InterfaceDeclarationNode node) throws CompilerException {
    }

    public void end(InterfaceGenericMethodDeclNode node) throws CompilerException {
    }

    public void end(InterfaceMemberDeclNode node) throws CompilerException {
    }

    public void end(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
    }

    public void end(InterfaceMethodOrFieldDeclNode node) throws CompilerException {
    }

    public void end(InterfaceMethodOrFieldRestNode node) throws CompilerException {
    }

    public void end(LiteralNode node) throws CompilerException {
    }

    public void end(LocalVariableDeclarationsStatementNode node) throws CompilerException {
    }

    public void end(MemberDeclNode node) throws CompilerException {
    }

    public void end(MethodeDeclaratorRestNode node) throws CompilerException {
    }

    public void end(MethodeOrFieldDeclNode node) throws CompilerException {
    }

    public void end(MethodeOrFieldRestNode node) throws CompilerException {
    }

    public void end(ModifierNode node) throws CompilerException {
    }

    public void end(NonWildcardTypeArgumentsNode node) throws CompilerException {
    }

    public void end(NonWildcardTypeArgumentsOrDiamond node) throws CompilerException {
    }

    public void end(NormalClassDeclarationNode node) throws CompilerException {
    }

    public void end(NormalInterfaceDeclarationNode node) throws CompilerException {
    }

    public void end(ParExpressionNode node) throws CompilerException {
    }

    public void end(PostfixOpNode node) throws CompilerException {
    }

    public void end(PrefixOpNode node) throws CompilerException {
    }

    public void end(PrimaryNode node) throws CompilerException {
    }

    public void end(QualifiedIdentifierListNode node) throws CompilerException {
    }

    public void end(QualifiedIdentifierNode node) throws CompilerException {
    }

    public void end(ReferenceTypeNode node) throws CompilerException {
    }

    public void end(ResourceNode node) throws CompilerException {
    }

    public void end(ResourcesNode node) throws CompilerException {
    }

    public void end(ResourceSpecificationNode node) throws CompilerException {
    }

    public void end(ReturnStatementNode node) throws CompilerException {
    }

    public void end(SelectorNode node) throws CompilerException {
    }

    public void end(StatementExpressionNode node) throws CompilerException {
    }

    public void end(StatementNode node) throws CompilerException {
    }

    public void end(SuperSuffixNode node) throws CompilerException {
    }

    public void end(SwitchBlockStatementGroupNode node) throws CompilerException {
    }

    public void end(SwitchBlockStatementGroupsNode node) throws CompilerException {
    }

    public void end(SwitchLabelNode node) throws CompilerException {
    }

    public void end(SwitchLabelsNode node) throws CompilerException {
    }

    public void end(SwitchStatementNode node) throws CompilerException {
    }

    public void end(SynchronizedStatementNode node) throws CompilerException {
    }

    public void end(ThrowStatementNode node) throws CompilerException {
    }

    public void end(TryStatementNode node) throws CompilerException {
    }

    public void end(TypeArgumentNode node) throws CompilerException {
    }

    public void end(TypeArgumentsListHelperNode node) throws CompilerException {
    }

    public void end(TypeArgumentsNode node) throws CompilerException {
    }

    public void end(TypeArgumentsOrDiamondNode node) throws CompilerException {
    }

    public void end(TypeDeclarationNode node) throws CompilerException {
    }

    public void end(TypeListNode node) throws CompilerException {
    }

    public void end(TypeNode node) throws CompilerException {
    }

    public void end(TypeParameterNode node) throws CompilerException {
    }

    public void end(TypeParametersNode node) throws CompilerException {
    }

    public void end(VariableDeclaratorIdNode node) throws CompilerException {
    }

    public void end(VariableDeclaratorNode node) throws CompilerException {
    }

    public void end(VariableDeclaratorRestNode node) throws CompilerException {
    }

    public void end(VariableDeclaratorsNode node) throws CompilerException {
    }

    public void end(VariableInitializerNode node) throws CompilerException {
    }

    public void end(VariableModifierNode node) throws CompilerException {
    }

    public void end(VoidInterfaceMethodDeclaratorRestNode node) throws CompilerException {
    }

    public void end(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
    }

    public void end(VoidMethodeDeclaratorRestNode node) throws CompilerException {
    }

    public void end(WhileStatementNode node) throws CompilerException {
    }
    /*TeaJay*/

    public void end(TypeSwitchStatementNode node) throws CompilerException {
    }

    public void end(TypeSwitchBlocksNode node) throws CompilerException {
    }

    public void end(TypeSwitchBlockNode node) throws CompilerException {
    }

    public void end(TypeSwitchLabelNode node) throws CompilerException {
    }

    public void end(ClosureTypeDecNode node) throws CompilerException {
    }

    public void end(ClosureTypeFormalParamNode node) throws CompilerException {
    }

    public void end(ClosureCreatorNode node) throws CompilerException {
    }

    public void end(ClosureReturnNode node) throws CompilerException {
    }

    public void end(ClosureEnvNode node) throws CompilerException {
    }

    public void end(ClosureEnvListNode node) throws CompilerException {
    }

    public void end(ClosureEnvItemNode node) throws CompilerException {
    }

    public void end(TjTypeDefNode node) throws CompilerException {
    }

    public void end(TjTypeDefMemberDeclNode node) throws CompilerException {
    }

    public void end(TjTypeDefConstructorDeclNode node) throws CompilerException {
    }

    public void end(TjTypeDefBodyNode node) throws CompilerException {
    }

    public void end(TjTypeDefBodyDeclarationNode node) throws CompilerException{
    }

    public void end(TjImplDeclarationNode node) throws CompilerException {
    }
    
    public void end(IdentTypeArgumentsOrDiamondNode node ) throws CompilerException{
    }
}
