/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.AssignmentOperatorNode;
import abstractsyntaxtree.Et1Node;
import abstractsyntaxtree.Expression1Node;
import abstractsyntaxtree.Expression1RestNode;
import abstractsyntaxtree.Expression2RestNode;
import abstractsyntaxtree.Expression3Node;
import abstractsyntaxtree.PostfixOpNode;
import abstractsyntaxtree.PrefixOpNode;
import abstractsyntaxtree.PrimaryNode;
import abstractsyntaxtree.SelectorNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractExpression3Visitor extends Visitor {

    @Override
    public abstract void begin(PrefixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(Expression3Node node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(PrimaryNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(SelectorNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(PostfixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(Expression2RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(Expression1RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(AssignmentOperatorNode node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(Expression1Node node) throws exceptions.CompilerException;

    @Override
    public abstract void begin(Et1Node node) throws exceptions.CompilerException;

    @Override
    public abstract void visit(PrefixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(Expression3Node node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(PrimaryNode node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(SelectorNode node) throws exceptions.CompilerException;

    @Override
    public abstract void visit(PostfixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(Expression2RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(Expression1RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract void visit(AssignmentOperatorNode node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(Expression1Node node) throws exceptions.CompilerException;

    @Override
    public abstract Visitor visit(Et1Node node) throws exceptions.CompilerException;

    @Override
    public abstract void end(PrefixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(Expression3Node node) throws exceptions.CompilerException;

    @Override
    public abstract void end(PrimaryNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(SelectorNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(PostfixOpNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(Expression2RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(Expression1RestNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(AssignmentOperatorNode node) throws exceptions.CompilerException;

    @Override
    public abstract void end(Expression1Node node) throws exceptions.CompilerException;

    @Override
    public abstract void end(Et1Node node) throws exceptions.CompilerException;
}
