/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.ExplicitGenericInvocationNode;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.InnerCreatorNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractIdentifierSuffixVisitor extends Visitor {

    public abstract void begin(ExplicitGenericInvocationNode node) throws exceptions.CompilerException;

    public abstract void begin(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void begin(InnerCreatorNode node) throws exceptions.CompilerException;

    public abstract void begin(ExpressionNode node) throws exceptions.CompilerException;

    public abstract void begin(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ExplicitGenericInvocationNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(InnerCreatorNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ExpressionNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(ExplicitGenericInvocationNode node) throws exceptions.CompilerException;

    public abstract void end(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(InnerCreatorNode node) throws exceptions.CompilerException;

    public abstract void end(ExpressionNode node) throws exceptions.CompilerException;

    public abstract void end(ArgumentsNode node) throws exceptions.CompilerException;
}
