/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.AssertStatementNode;
import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.BreakStatementNode;
import abstractsyntaxtree.ContinueStatementNode;
import abstractsyntaxtree.DoStatementNode;
import abstractsyntaxtree.ForStatementNode;
import abstractsyntaxtree.IdentDoublePointStatementNode;
import abstractsyntaxtree.IfStatementNode;
import abstractsyntaxtree.ReturnStatementNode;
import abstractsyntaxtree.StatementExpressionNode;
import abstractsyntaxtree.SwitchStatementNode;
import abstractsyntaxtree.SynchronizedStatementNode;
import abstractsyntaxtree.ThrowStatementNode;
import abstractsyntaxtree.TryStatementNode;
import abstractsyntaxtree.TypeSwitchStatementNode;
import abstractsyntaxtree.WhileStatementNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractStatementVisitor extends Visitor {

    public abstract void begin(BlockNode node) throws exceptions.CompilerException;

    public abstract void begin(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(StatementExpressionNode node) throws exceptions.CompilerException;

    public abstract void begin(IfStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(AssertStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(SwitchStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(WhileStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(DoStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(ForStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(BreakStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(ContinueStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(ReturnStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(ThrowStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(TryStatementNode node) throws exceptions.CompilerException;

    public abstract void begin(TypeSwitchStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(BlockNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(StatementExpressionNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(IfStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(AssertStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(SwitchStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(WhileStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(DoStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ForStatementNode node) throws exceptions.CompilerException;

    public abstract void visit(BreakStatementNode node) throws exceptions.CompilerException;

    public abstract void visit(ContinueStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ReturnStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ThrowStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TryStatementNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeSwitchStatementNode node) throws exceptions.CompilerException;

    public abstract void end(BlockNode node) throws exceptions.CompilerException;

    public abstract void end(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public abstract void end(StatementExpressionNode node) throws exceptions.CompilerException;

    public abstract void end(IfStatementNode node) throws exceptions.CompilerException;

    public abstract void end(AssertStatementNode node) throws exceptions.CompilerException;

    public abstract void end(SwitchStatementNode node) throws exceptions.CompilerException;

    public abstract void end(WhileStatementNode node) throws exceptions.CompilerException;

    public abstract void end(DoStatementNode node) throws exceptions.CompilerException;

    public abstract void end(ForStatementNode node) throws exceptions.CompilerException;

    public abstract void end(BreakStatementNode node) throws exceptions.CompilerException;

    public abstract void end(ContinueStatementNode node) throws exceptions.CompilerException;

    public abstract void end(ReturnStatementNode node) throws exceptions.CompilerException;

    public abstract void end(ThrowStatementNode node) throws exceptions.CompilerException;

    public abstract void end(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public abstract void end(TryStatementNode node) throws exceptions.CompilerException;

    public abstract void end(TypeSwitchStatementNode node) throws exceptions.CompilerException;
}
