/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TjTypeDefBodyNode;
import abstractsyntaxtree.TypeListNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */

/*
 * private final TypeParametersNode genericParameters;
 private final TypeNode extendsFrom;
 private final TypeListNode implementsThis;
 private final TjTypeDefBodyNode typeDefBody;
 */
public abstract class AbstractTjTypeDefVisitor extends Visitor {

    public abstract void begin(ModifierNode node) throws exceptions.CompilerException;
    
    public abstract void begin(TypeParametersNode node) throws exceptions.CompilerException;

    public abstract void begin(TypeNode node) throws exceptions.CompilerException;

    public abstract void begin(TypeListNode node) throws exceptions.CompilerException;

    public abstract void begin(TjTypeDefBodyNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeParametersNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TypeListNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(TjTypeDefBodyNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ModifierNode node) throws exceptions.CompilerException;
    
    public abstract void end(TypeParametersNode node) throws exceptions.CompilerException;

    public abstract void end(TypeNode node) throws exceptions.CompilerException;

    public abstract void end(TypeListNode node) throws exceptions.CompilerException;

    public abstract void end(TjTypeDefBodyNode node) throws exceptions.CompilerException;

    public abstract void end(ModifierNode node) throws exceptions.CompilerException;
}
