/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeListVisitor;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author cefour
 */
public class TypeListVisitor extends AbstractTypeListVisitor<List<String>> {

    private TypeVisitor typeVisitor;
    private List<String> typeList;

    @Override
    public void begin(TypeNode node) {
        this.typeVisitor = new TypeVisitor();
        this.typeList = new LinkedList<>();
    }

    @Override
    public Visitor visit(TypeNode node) {
        return this.typeVisitor;
    }

    @Override
    public void end(TypeNode node) {
        typeList.add(typeVisitor.typeName);
    }

    @Override
    public List<String> getContainer() {
        return typeList;
    }
}
