/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.ArrayInitializerNode;
import abstractsyntaxtree.ExpressionNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVariableInitializerVisitor;
import codegeneration.javavisitor.expression.expressiontransform.ExpressionTransformer;
import codegeneration.javavisitor.expression.expressiontransform.VariableInitExpressionCreator;
import exceptions.CompilerException;
import java.util.LinkedList;
import java.util.List;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.JVMInstructionList;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class VariableInitializerVisitor extends AbstractVariableInitializerVisitor {

    private CaptureExpressionVisitor rValueExpressionVisitor;
    private final MethodInfo info;
    private final ClassFile classFile;
    private final String varName;
    private final String typeName;

    VariableInitializerVisitor(ClassFile classFile, MethodInfo info, String varName, String typeName) {
        this.classFile = classFile;
        this.info = info;
        this.varName = varName;
        this.typeName = typeName;
    }

    @Override
    public void begin(ArrayInitializerNode node) throws CompilerException {
    }

    @Override
    public void begin(ExpressionNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ArrayInitializerNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(ExpressionNode node) throws CompilerException {
        return rValueExpressionVisitor = new CaptureExpressionVisitor();
    }

    @Override
    public void end(ArrayInitializerNode node) throws CompilerException {
    }

    @Override
    public void end(ExpressionNode node) throws CompilerException {
        VariableInitExpressionCreator transformer = new VariableInitExpressionCreator(classFile, info, typeName, varName, node);

        JVMInstructionList methodInstructions = this.info.getCode().getInstructionList();

        transformer.makeInstructions();

        // MethodRefInfo ref = InstructionCreator.CreateConstructor(typeName, "int");
        //methodInstructions.add(new InvokeSpecial(ref));

        //  LocalEntry entry = SymbolFacade.instance().getLocalTable().getEntry(varName);

        // methodInstructions.add(new AStore(entry.getIndex()));
        //InstructionCreator.MakeDebugOutputOfLocalReference(info, varName);



    }
}

class CaptureExpressionVisitor extends Visitor {

    public List<ExpressionNode> expList = new LinkedList<>();

    public void begin(ExpressionNode node) {
        expList.add(node);
    }
}
