/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.classes;

import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.MemberDeclNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.ModifierNode.Modifier;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClassBodyDeclarationVisitor;
import codegeneration.abstractvisitors.AbstractMemberDeclVisitor;
import codegeneration.abstractvisitors.AbstractModifierVisitor;
import codegeneration.javavisitor.MemberDeclVisitor;
import codegeneration.javavisitor.ModifierVisitor;
import java.util.ArrayList;
import java.util.List;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.ALoad;
import teajay.bytecode.attributes.code.InvokeSpecial;
import teajay.bytecode.attributes.code.Return;
import teajay.bytecode.cpool.ClassInfo;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.MethodDescriptor;
import teajay.bytecode.cpool.MethodRefInfo;
import teajay.bytecode.cpool.NameAndTypeInfo;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.methods.MethodAccessFlag;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class ClassBodyDeclarationVisitor extends AbstractClassBodyDeclarationVisitor {

    private final ClassFile classFile;
    private AbstractModifierVisitor modifierVisitor;
    private AbstractMemberDeclVisitor memberDeclVisitor;
    private List<ModifierNode> modis = new ArrayList<>();
    private boolean wasEntry = false;

    ClassBodyDeclarationVisitor(ClassFile classFile) {
        this.classFile = classFile;
    }

    @Override
    public void begin(ModifierNode node) {
        this.modis.add(node);
    }

    @Override
    public void begin(MemberDeclNode node) {
    }

    @Override
    public void begin(BlockNode node) {
    }

    @Override
    public Visitor visit(ModifierNode node) {
        return this.modifierVisitor = new ModifierVisitor();
    }

    @Override
    public Visitor visit(MemberDeclNode node) {
        return this.memberDeclVisitor = new MemberDeclVisitor(classFile, this.modis);
    }

    @Override
    public Visitor visit(BlockNode node) {
        return null;
    }

    @Override
    public void end(ModifierNode node) {
    }

    @Override
    public void end(MemberDeclNode node) {
    }

    @Override
    public void end(BlockNode node) {
    }
}
