/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.compilationunit;

import codegeneration.abstractvisitors.AbstractQualifiedIdentifierVisitor;
import codegeneration.abstractvisitors.AbstractCompilationUnitHelperVisitor;
import abstractsyntaxtree.AnnotationsNode;
import abstractsyntaxtree.QualifiedIdentifierNode;
import codegeneration.Visitor;
import codegeneration.javavisitor.QualifiedIdentifierVisitor;
import exceptions.CompilerException;
import java.util.Iterator;

/**
 *
 * @author cefour
 */
public class CompilationUnitHelperVisitor extends AbstractCompilationUnitHelperVisitor {

    private AbstractQualifiedIdentifierVisitor qIdVisitor;
    private String packageName;

    /*visit qualified identifier node*/
    @Override
    public void begin(QualifiedIdentifierNode node) throws CompilerException {
        this.qIdVisitor = new QualifiedIdentifierVisitor();
    }

    @Override
    public Visitor visit(QualifiedIdentifierNode node) throws CompilerException {
        return this.qIdVisitor;
    }

    @Override
    public void end(QualifiedIdentifierNode node) throws CompilerException {
        StringBuilder builder = new StringBuilder();
        Iterator<String> iter = this.qIdVisitor.getQualifiedNameList().iterator();
        while (iter.hasNext()) {
            builder.append(iter.next());
            if (iter.hasNext()) {
                builder.append('/');
            }
        }
        this.packageName = builder.toString();
    }

    /*visit annotations node*/
    @Override
    public void begin(AnnotationsNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(AnnotationsNode node) throws CompilerException {
        return this;
    }

    @Override
    public void end(AnnotationsNode node) throws CompilerException {
    }

    @Override
    public String getPackageName() {
        return this.packageName;
    }
}
