/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.Expression3Node;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.InfixOpNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractExpression2RestVisitor;
import codegeneration.instruction.InstructionCreator;
import exceptions.CompilerException;
import java.util.Deque;
import teajay.bytecode.attributes.code.IAdd;
import teajay.bytecode.attributes.code.IMul;
import teajay.bytecode.attributes.code.JVMInstructionList;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author cefour
 */
class Expression2RestVisitor extends AbstractExpression2RestVisitor {

    private final ExpressionEnvironment env;
    private final Deque<InfixOpNode.InfixOps> stack;

    public Expression2RestVisitor(ExpressionEnvironment env, Deque<InfixOpNode.InfixOps> stack) {
        this.env = env;
        this.stack = stack;
    }

    @Override
    public void begin(Expression3Node node) {
    }

    @Override
    public void begin(InfixOpNode node) {
    }

    @Override
    public void begin(TypeNode node) {
    }

    @Override
    public Visitor visit(Expression3Node node) {
       // this.env.expressionType = Expression3Visitor.ExpressionType.RVALUE;
        return new Expression3Visitor(this.env, this.stack, false);
    }

    @Override
    public void visit(InfixOpNode node) throws CompilerException {
      //  try {
           // if (env.expressionType == Expression3Visitor.ExpressionType.LVALUE) {
           //     throw new CompilerException("Not a statement", node.getSymbol());
           // }
            InfixOpNode.InfixOps operator = node.getOperator();
            int stackPriority = -1;
            if (!this.stack.isEmpty()) {
                stackPriority = this.stack.peek().getPriority();
                int opPriority = operator.getPriority();
                if (stackPriority >= opPriority) {
                    JVMInstructionList instructionList = this.env.getMethod().getCode().getInstructionList();
                    InfixOpNode.InfixOps firstOperator = this.stack.pop();
                  //  InstructionCreator.PutOperatorInstruction(env, instructionList, firstOperator);
                }
            }
            stack.push(operator);
      //  } catch (CompilerException ex) {
       //     ex.printStackTrace(System.err);
       //     System.exit(-1);
       // }
    }

    @Override
    public Visitor visit(TypeNode node) {
        return null;
    }

    @Override
    public void end(Expression3Node node) {
    }

    @Override
    public void end(InfixOpNode node) {
    }

    @Override
    public void end(TypeNode node) {
    }
}
