/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.InfixOpNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractParExpressionVisitor;
import codegeneration.instruction.InstructionCreator;
import exceptions.CompilerException;
import java.util.Deque;
import java.util.LinkedList;

/**
 *
 * @author cefour
 */
public class ParExpressioVisitor extends AbstractParExpressionVisitor {

    private final ExpressionEnvironment env;
    private ExpressionEnvironment newEnv;
    private Deque<InfixOpNode.InfixOps> stack;

    public ParExpressioVisitor(ExpressionEnvironment env) {
        this.env = env;
    }

    @Override
    public void begin(ExpressionNode node) {
        stack = new LinkedList<>();
        //newEnv = new ExpressionEnvironment(env.getFile(), env.getMethod());
        //newEnv.setLabel(env.getLabel());
    }

    @Override
    public Visitor visit(ExpressionNode node) {
        return new ExpressionVisitor(newEnv, stack, true);
    }

    @Override
    public void end(ExpressionNode node) throws CompilerException {
       // InstructionCreator.PutOperatorInstructions(newEnv, env.getMethod(), stack);
        env.setResultType(newEnv.getResultType());

    }
}
