/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.method;

import abstractsyntaxtree.ConstructorDeclaratorRestNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractConstructorDeclaratorRestHelperVisitor;
import exceptions.CompilerException;
import java.util.List;
import teajay.bytecode.AccessFlag;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.Return;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.MethodDescriptor;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.methods.MethodAccessFlag;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class ConstructorDeclaratorRestHelperVisitor extends AbstractConstructorDeclaratorRestHelperVisitor {

    private final String constructorName;
    private List<ModifierNode> modis;
    private final ClassFile classFile;

    public ConstructorDeclaratorRestHelperVisitor(ClassFile classFile, List<ModifierNode> modis, String identifier) throws CompilerException {
        this.classFile = classFile;
        this.modis = modis;
        this.constructorName = identifier;
        this.isCorrectConstructorName();

    }
    /*
     * This constructor ist possible to remove because the modifer list is always not empty; 
     */

    public ConstructorDeclaratorRestHelperVisitor(ClassFile classFile, String identifier) throws CompilerException {
        this.classFile = classFile;
        this.constructorName = identifier;
        this.isCorrectConstructorName();

    }

    @Override
    public void begin(ConstructorDeclaratorRestNode node) {
    }

    @Override
    public Visitor visit(ConstructorDeclaratorRestNode node) {
        return new ConstructorDeclaratorRestVisitor(classFile, modis);
    }

    @Override
    public void end(ConstructorDeclaratorRestNode node) {
    }

    private void isCorrectConstructorName() throws CompilerException {
        if (!this.classFile.getThis().getSimpleName().equals(this.constructorName)) {
            throw new CompilerException("Constructor name does not match with the class name");
        }
    }
}
