/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.method;

import abstractsyntaxtree.MethodeOrFieldRestNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.ModifierNode.Modifier;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMethodeOrFieldDeclVisitor;
import codegeneration.abstractvisitors.AbstractTypeVisitor;
import codegeneration.javavisitor.TypeVisitor;
import java.util.List;
import teajay.bytecode.ClassFile;

/**
 *
 * @author cefour
 */
public class MethodeOrFieldDeclVisitor extends AbstractMethodeOrFieldDeclVisitor {

    private final ClassFile classFile;
    private List<ModifierNode> modis;
    private MethodeOrFieldRestVisitor methodOrFieldRestVisitor;
    private final String name;
    private AbstractTypeVisitor typeVisitor;

    public MethodeOrFieldDeclVisitor(ClassFile classFile, List<ModifierNode> modis, String name) {
        this.classFile = classFile;
        this.modis = modis;
        this.name = name;
    }

    public MethodeOrFieldDeclVisitor(ClassFile classFile, String name) {
        this.classFile = classFile;
        this.name = name;
    }

    @Override
    public void begin(TypeNode node) {
    }

    @Override
    public void begin(MethodeOrFieldRestNode node) {
    }

    @Override
    public Visitor visit(TypeNode node) {
        return this.typeVisitor = new TypeVisitor();
    }

    @Override
    public Visitor visit(MethodeOrFieldRestNode node) {
        return this.methodOrFieldRestVisitor = new MethodeOrFieldRestVisitor(this.classFile, modis, this.typeVisitor, this.name);
    }

    @Override
    public void end(TypeNode node) {
    }

    @Override
    public void end(MethodeOrFieldRestNode node) {
    }
}
