/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.statement;

import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.InfixOpNode;
import abstractsyntaxtree.ParExpressionNode;
import abstractsyntaxtree.StatementNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractIfStatementVisitor;
import codegeneration.environment.ExpressionEnvironment;
import codegeneration.javavisitor.expression.expressiontransform.ParExpressioVisitor;
import exceptions.CompilerException;
import java.util.Deque;
import java.util.LinkedList;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.Label;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class IfStatementVisitor extends AbstractIfStatementVisitor {

    private final ClassFile classFile;
    private final MethodInfo info;
    ExpressionEnvironment env;
    Deque<InfixOpNode.InfixOps> stack = new LinkedList<>();
    private Label l;

    IfStatementVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
        //this.env = new ExpressionEnvironment(stage3Env,classFile, info);
    }

    @Override
    public void begin(ParExpressionNode node) {
    }

    @Override
    public void begin(StatementNode node) {
    }

    @Override
    public Visitor visit(ParExpressionNode node) {
        return new ParExpressioVisitor(env);
    }

    @Override
    public Visitor visit(StatementNode node) {

        return new StatementVisitor(classFile, info);
    }

    @Override
    public void end(ParExpressionNode node) {
        /*try {
            if (env.getResultType().equals("java/lang/Boolean")) {
                MethodRefInfo ref = MethodRefInfo.make("java/lang/Boolean", "booleanValue", "boolean");
                info.getCode().getInstructionList().add(new InvokeVirtual(ref));
                this.l = new Label("ifSprung");
                info.getCode().getInstructionList().add(new If0(IMode.eq, l));
                System.out.println(new InvokeVirtual(ref));
                System.out.println(new If0(IMode.eq, l));
            }
        } catch (ByteCodeException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }*/
    }

    @Override
    public void end(StatementNode node) {
    }

    public Label getLabel() {
        return this.l;
    }

    @Override
    public void begin(BlockNode node) throws CompilerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Visitor visit(BlockNode node) throws CompilerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void end(BlockNode node) throws CompilerException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
