/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.statement;

import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.ParExpressionNode;
import abstractsyntaxtree.StatementNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractWhileStatementVisitor;
import codegeneration.environment.ExpressionEnvironment;
import codegeneration.javavisitor.expression.expressiontransform.ParExpressioVisitor;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.code.Goto;
import teajay.bytecode.attributes.code.IMode;
import teajay.bytecode.attributes.code.If0;
import teajay.bytecode.attributes.code.InvokeVirtual;
import teajay.bytecode.attributes.code.Label;
import teajay.bytecode.cpool.MethodRefInfo;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class WhileStatementVisitor extends AbstractWhileStatementVisitor {

    private final ClassFile classFile;
    private final MethodInfo info;
    private Label loopLabel;
    private ExpressionEnvironment env;
    private Label jmpOverLoopLabel;

    public WhileStatementVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
    }

    @Override
    public void begin(ParExpressionNode node) {
    }

    @Override
    public void begin(BlockNode node) {
    }

    @Override
    public Visitor visit(ParExpressionNode node) {
      /*  this.env = new ExpressionEnvironment(classFile, info);
        this.loopLabel = new Label("LoopLabel");
        env.setLabel(this.loopLabel);*/
        //return new ParExpressioVisitor(env);
        return null;
    }

    @Override
    public Visitor visit(BlockNode node) {
        return new StatementVisitor(classFile, info);
    }

    @Override
    public void end(ParExpressionNode node) {
        try {
            if (env.getResultType().equals("java/lang/Boolean")) {
                MethodRefInfo ref = MethodRefInfo.make("java/lang/Boolean", "booleanValue", "boolean");
                info.getCode().getInstructionList().add(new InvokeVirtual(ref));
                this.jmpOverLoopLabel = new Label("overLoop");
                info.getCode().getInstructionList().add(new If0(IMode.eq, this.jmpOverLoopLabel));
                System.out.println(new InvokeVirtual(ref));
                System.out.println(new If0(IMode.eq, this.jmpOverLoopLabel));
            }
        } catch (ByteCodeException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }
    }

    @Override
    public void end(BlockNode node) {
        try {
            info.getCode().getInstructionList().add(new Goto(this.loopLabel));
            System.out.println(new Goto(this.loopLabel));
        } catch (ByteCodeException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }
    }

    public Label getJmpOverWhile() {
        return this.jmpOverLoopLabel;
    }
}
