/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package lexer;

import java.lang.reflect.Field;
/**
 * 
 * @author Michael (Burzan | Kußmann)
 */
public class Sym {

    private static int cnt = 0;
    public static final int ABSTRACT = ++cnt;
    public static final int ASSERT = ++cnt;
    public static final int BYTE = ++cnt;
    public static final int SHORT = ++cnt;
    public static final int CHAR = ++cnt;
    public static final int INT = ++cnt;
    public static final int LONG = ++cnt;
    public static final int FLOAT = ++cnt;
    public static final int DOUBLE = ++cnt;
    public static final int BOOLEAN = ++cnt;
    public static final int BREAK = ++cnt;
    public static final int IDENTIFIER = ++cnt;
    public static final int EOF = ++cnt;
    public static final int CASE = ++cnt;
    public static final int CATCH = ++cnt;
    public static final int TRY = ++cnt;
    public static final int CONST = ++cnt;
    public static final int CONTINUE = ++cnt;
    public static final int DEFAULT = ++cnt;
    public static final int DO = ++cnt;
    public static final int PACKAGE = ++cnt;
    public static final int WHILE = ++cnt;
    public static final int ELSE = ++cnt;
    public static final int ENUM = ++cnt;
    public static final int EXTENDS = ++cnt;
    public static final int FOR = ++cnt;
    public static final int IMPLEMENTS = ++cnt;
    public static final int IF = ++cnt;
    public static final int IMPORT = ++cnt;
    public static final int NEW = ++cnt;
    public static final int OF = ++cnt;
    public static final int OPERATOR = ++cnt;
    public static final int PUBLIC = ++cnt;
    public static final int PRIVATE = ++cnt;
    public static final int RETURN = ++cnt;
    public static final int SWITCH = ++cnt;
    public static final int TYPESWITCH = ++cnt;
    public static final int STATIC = ++cnt;
    public static final int THROW = ++cnt;
    public static final int THROWS = ++cnt;
    public static final int THIS = ++cnt;
    public static final int SUPER = ++cnt;
    public static final int VOLATILE = ++cnt;
    public static final int OP_EQ = ++cnt;
    public static final int OP_EQEQ = ++cnt;
    public static final int OP_PLUS = ++cnt;
    public static final int OP_PLUS_PLUS = ++cnt;
    public static final int OP_SUB = ++cnt;
    public static final int OP_SUB_SUB = ++cnt;
    public static final int OP_MULT = ++cnt;
    public static final int OP_DIV = ++cnt;
    public static final int OP_MOD = ++cnt;
    public static final int OP_NOT = ++cnt;
    public static final int OP_XOR = ++cnt;
    public static final int OP_OR = ++cnt;
    public static final int OP_AND = ++cnt;
    public static final int OP_NEQ = ++cnt;
    public static final int OP_LESS = ++cnt;
    public static final int OP_GREATER = ++cnt;
    public static final int OP_LEQ = ++cnt;
    public static final int OP_GEQ = ++cnt;
    public static final int OP_NEG = ++cnt;
    public static final int BRACKET_OPEN = ++cnt;
    public static final int BRACKET_CLOSE = ++cnt;
    public static final int CURLY_OPEN = ++cnt;
    public static final int CURLY_CLOSE = ++cnt;
    public static final int SEMICOLON = ++cnt;
    public static final int COMMA = ++cnt;
    public static final int COLON = ++cnt;
    public static final int DOT = ++cnt;
    public static final int TRIPLEDOT = ++cnt;
    public static final int DOTSTAR = ++cnt;
    public static final int CLASS = ++cnt;
    public static final int INTERFACE = ++cnt;
    public static final int AT = ++cnt;
    public static final int EDGECLAMPS_OPEN = ++cnt;
    public static final int EDGECLAMPS_CLOSE = ++cnt;
    public static final int QUESTIONMARK = ++cnt;
    public static final int FINAL = ++cnt;
    public static final int FINALLY = ++cnt;
    public static final int NATIVE = ++cnt;
    public static final int SYNCHRONIZED = ++cnt;
    public static final int TRANSIENT = ++cnt;
    public static final int STRICTFP = ++cnt;
    public static final int PROTECTED = ++cnt;
    public static final int VOID = ++cnt;
    public static final int OP_PLUS_SET = ++cnt;
    public static final int OP_SUB_SET = ++cnt;
    public static final int OP_MULT_SET = ++cnt;
    public static final int OP_DIV_SET = ++cnt;
    public static final int OP_AND_SET = ++cnt;
    public static final int OP_OR_SET = ++cnt;
    public static final int OP_XOR_SET = ++cnt;
    public static final int OP_MOD_SET = ++cnt;
    public static final int OP_LEFT_SHIFT_SET = ++cnt;
    public static final int OP_RIGHT_SHIFT_SET = ++cnt;
    public static final int OP_RIGHT_RIGHT_SHIFT_SET = ++cnt;
    public static final int OR = ++cnt;
    public static final int AND = ++cnt;
    public static final int OP_LEFT_SHIFT = ++cnt;
    public static final int OP_RIGHT_SHIFT = ++cnt;
    public static final int OP_RIGHT_RIGHT_SHIFT = ++cnt;
    public static final int INSTANCEOF = ++cnt;
    public static final int WHITESPACE = ++cnt;
    public static final int GOTO = ++cnt;
    public static final int INT_L = ++cnt;
    public static final int FLOAT_L = ++cnt;
    public static final int LONG_L = ++cnt;
    public static final int DOUBLE_L = ++cnt;
    public static final int CHAR_L = ++cnt;
    public static final int STRING_L = ++cnt;
    public static final int BOOL_L = ++cnt;
    public static final int NULL_L = ++cnt;
    public static final int TYPEDEF = ++cnt;
    public static final int TYPEIMPL = ++cnt;
    public static final int CLOSUREDEC = ++cnt;
    public static final int CLOSUREDEF = ++cnt;
    public static final int INTERFACES = ++cnt;

    public static String getNameByID(int id) {
        try {
            Field[] fields = Sym.class.getFields();
            for (Field field : fields) {
                int value = field.getInt(null);
                if (id == value) {
                    return field.getName();
                }
            }
        } catch (IllegalArgumentException | IllegalAccessException ex) {
            ex.printStackTrace(System.err);
        }
        return "NOTSYM";
    }
}
