/* The following code was generated by JFlex 1.4.3 on 11.10.17 15:51 */

package lexer;
import exceptions.LexerException;
import java.io.IOException;
import static lexer.UTF16.utf16Decode;

/**
 * This Reader maps unicode escape sequences to its respective characters or if
 * necessary to its code points.
 * @author Michael Kußmann <michi@outx.de>
 */

public final class UnicodeFilteredReader extends java.io.Reader {

  /** This character denotes the end of file */
  private static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  private static final int YYINITIAL = 0;
  private static final int UNICODE_ESCAPE = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  0,  1, 1
  };

  /** 
   * Translates characters to character classes
   */
  private static final String ZZ_CMAP_PACKED = 
    "\60\0\12\1\7\0\6\1\25\0\1\2\4\0\6\1\16\0\1\3"+
    "\uff8a\0";

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\2\0\1\1\1\2\2\3\2\1\1\4\1\0\1\1"+
    "\2\0\2\1\1\5\1\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\3\1\1\0\341\1";

  private static int [] zzUnpackAction() {
    int [] result = new int[295];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\4\0\10\0\14\0\20\0\24\0\30\0\34"+
    "\0\40\0\44\0\50\0\54\0\60\0\64\0\70\0\20"+
    "\0\74\0\100\0\104\0\110\0\114\0\120\0\124\0\130"+
    "\0\134\0\140\0\144\0\150\0\154\0\160\0\164\0\170"+
    "\0\174\0\200\0\204\0\210\0\214\0\220\0\224\0\230"+
    "\0\234\0\240\0\244\0\250\0\254\0\260\0\264\0\270"+
    "\0\274\0\300\0\304\0\310\0\314\0\320\0\324\0\330"+
    "\0\334\0\340\0\344\0\350\0\354\0\360\0\364\0\370"+
    "\0\374\0\u0100\0\u0104\0\u0108\0\u010c\0\u0110\0\u0114\0\20"+
    "\0\u0118\0\u011c\0\u0120\0\u0124\0\u0128\0\u012c\0\u0130\0\u0134"+
    "\0\u0138\0\u013c\0\u0140\0\u0144\0\u0148\0\u014c\0\u0150\0\u0154"+
    "\0\u0158\0\u015c\0\u0160\0\u0164\0\u0168\0\u016c\0\u0170\0\u0174"+
    "\0\u0178\0\u017c\0\u0180\0\u0184\0\u0188\0\u018c\0\u0190\0\u0194"+
    "\0\u0198\0\u019c\0\u01a0\0\u01a4\0\u01a8\0\u01ac\0\u01b0\0\u01b4"+
    "\0\u01b8\0\u01bc\0\u01c0\0\u01c4\0\u01c8\0\u01cc\0\u01d0\0\u01d4"+
    "\0\u01d8\0\u01dc\0\u01e0\0\u01e4\0\u01e8\0\u01ec\0\u01f0\0\u01f4"+
    "\0\u01f8\0\u01fc\0\u0200\0\u0204\0\u0208\0\u020c\0\u0210\0\u0214"+
    "\0\u0218\0\u021c\0\u0220\0\u0224\0\u0228\0\u022c\0\u0230\0\u0234"+
    "\0\u0238\0\u023c\0\u0240\0\u0244\0\u0248\0\u024c\0\u0250\0\u0254"+
    "\0\u0258\0\u025c\0\u0260\0\u0264\0\u0268\0\u026c\0\u0270\0\u0274"+
    "\0\u0278\0\u027c\0\u0280\0\u0284\0\u0288\0\u028c\0\u0290\0\u0294"+
    "\0\u0298\0\u029c\0\u02a0\0\u02a4\0\u02a8\0\u02ac\0\u02b0\0\u02b4"+
    "\0\u02b8\0\u02bc\0\u02c0\0\u02c4\0\u02c8\0\u02cc\0\u02d0\0\u02d4"+
    "\0\u02d8\0\u02dc\0\u02e0\0\u02e4\0\u02e8\0\u02ec\0\u02f0\0\u02f4"+
    "\0\u02f8\0\u02fc\0\u0300\0\u0304\0\u0308\0\u030c\0\u0310\0\u0314"+
    "\0\u0318\0\u031c\0\u0320\0\u0324\0\u0328\0\u032c\0\u0330\0\u0334"+
    "\0\u0338\0\u033c\0\u0340\0\u0344\0\u0348\0\u034c\0\u0350\0\u0354"+
    "\0\u0358\0\u035c\0\u0360\0\u0364\0\u0368\0\u036c\0\u0370\0\u0374"+
    "\0\u0378\0\u037c\0\u0380\0\u0384\0\u0388\0\u038c\0\u0390\0\u0394"+
    "\0\u0398\0\u039c\0\u03a0\0\u03a4\0\u03a8\0\u03ac\0\u03b0\0\u03b4"+
    "\0\u03b8\0\u03bc\0\u03c0\0\u03c4\0\u03c8\0\u03cc\0\u03d0\0\u03d4"+
    "\0\u03d8\0\u03dc\0\u03e0\0\u03e4\0\u03e8\0\u03ec\0\u03f0\0\u03f4"+
    "\0\u03f8\0\u03fc\0\u0400\0\u0404\0\u0408\0\u040c\0\u0410\0\u0414"+
    "\0\u0418\0\u041c\0\u0420\0\u0424\0\u0428\0\u042c\0\u0430\0\u0434"+
    "\0\u0438\0\u043c\0\u0440\0\u0444\0\u0448\0\u044c\0\u0450\0\u0454"+
    "\0\u0458\0\u045c\0\u0460\0\u0464\0\u0468\0\u046c\0\u0470\0\u0474"+
    "\0\u0478\0\u047c\0\u0480\0\u0484\0\u0488\0\u048c\0\u0490";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[295];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\2\3\1\4\1\3\1\5\1\6\2\5\2\7\1\0"+
    "\1\7\2\0\1\10\1\11\5\0\1\12\2\0\2\13"+
    "\1\0\1\13\2\0\1\14\4\0\1\11\1\0\1\15"+
    "\2\0\2\16\1\0\1\16\2\0\1\17\2\0\1\20"+
    "\2\0\2\21\1\0\1\21\2\0\1\22\1\0\2\23"+
    "\1\0\1\23\2\0\1\24\1\0\2\25\1\0\1\25"+
    "\2\0\1\26\1\0\2\27\1\0\1\27\2\0\1\30"+
    "\1\0\2\31\1\0\1\31\2\0\1\32\1\0\2\33"+
    "\1\0\1\33\2\0\1\34\1\0\2\35\1\0\1\35"+
    "\2\0\1\36\1\0\2\37\1\0\1\37\2\0\1\40"+
    "\1\0\2\41\1\0\1\41\2\0\1\42\1\0\2\43"+
    "\1\0\1\43\2\0\1\44\1\0\2\45\1\0\1\45"+
    "\2\0\1\46\1\0\2\47\1\0\1\47\2\0\1\50"+
    "\1\0\2\51\1\0\1\51\2\0\1\52\1\0\2\53"+
    "\1\0\1\53\2\0\1\54\1\0\2\55\1\0\1\55"+
    "\2\0\1\56\1\0\2\57\1\0\1\57\2\0\1\60"+
    "\1\0\2\61\1\0\1\61\2\0\1\62\1\0\2\63"+
    "\1\0\1\63\2\0\1\64\1\0\2\65\1\0\1\65"+
    "\2\0\1\66\1\0\2\67\1\0\1\67\2\0\1\70"+
    "\1\0\2\71\1\0\1\71\2\0\1\72\1\0\2\73"+
    "\1\0\1\73\2\0\1\74\1\0\2\75\1\0\1\75"+
    "\2\0\1\76\1\0\2\77\1\0\1\77\2\0\1\100"+
    "\1\0\2\101\1\0\1\101\2\0\1\102\1\0\2\103"+
    "\1\0\1\103\2\0\1\104\1\0\2\105\1\0\1\105"+
    "\2\0\1\106\1\0\2\107\1\0\1\107\2\0\1\110"+
    "\1\0\2\111\1\0\1\111\2\112\1\0\1\112\2\113"+
    "\1\0\1\113\2\114\1\0\1\114\2\115\1\0\1\115"+
    "\2\116\1\0\1\116\2\117\1\0\1\117\2\120\1\0"+
    "\1\120\2\121\1\0\1\121\2\122\1\0\1\122\2\123"+
    "\1\0\1\123\2\124\1\0\1\124\2\125\1\0\1\125"+
    "\2\126\1\0\1\126\2\127\1\0\1\127\2\130\1\0"+
    "\1\130\2\131\1\0\1\131\2\132\1\0\1\132\2\133"+
    "\1\0\1\133\2\134\1\0\1\134\2\135\1\0\1\135"+
    "\2\136\1\0\1\136\2\137\1\0\1\137\2\140\1\0"+
    "\1\140\2\141\1\0\1\141\2\142\1\0\1\142\2\143"+
    "\1\0\1\143\2\144\1\0\1\144\2\145\1\0\1\145"+
    "\2\146\1\0\1\146\2\147\1\0\1\147\2\150\1\0"+
    "\1\150\2\151\1\0\1\151\2\152\1\0\1\152\2\153"+
    "\1\0\1\153\2\154\1\0\1\154\2\155\1\0\1\155"+
    "\2\156\1\0\1\156\2\157\1\0\1\157\2\160\1\0"+
    "\1\160\2\161\1\0\1\161\2\162\1\0\1\162\2\163"+
    "\1\0\1\163\2\164\1\0\1\164\2\165\1\0\1\165"+
    "\2\166\1\0\1\166\2\167\1\0\1\167\2\170\1\0"+
    "\1\170\2\171\1\0\1\171\2\172\1\0\1\172\2\173"+
    "\1\0\1\173\2\174\1\0\1\174\2\175\1\0\1\175"+
    "\2\176\1\0\1\176\2\177\1\0\1\177\2\200\1\0"+
    "\1\200\2\201\1\0\1\201\2\202\1\0\1\202\2\203"+
    "\1\0\1\203\2\204\1\0\1\204\2\205\1\0\1\205"+
    "\2\206\1\0\1\206\2\207\1\0\1\207\2\210\1\0"+
    "\1\210\2\211\1\0\1\211\2\212\1\0\1\212\2\213"+
    "\1\0\1\213\2\214\1\0\1\214\2\215\1\0\1\215"+
    "\2\216\1\0\1\216\2\217\1\0\1\217\2\220\1\0"+
    "\1\220\2\221\1\0\1\221\2\222\1\0\1\222\2\223"+
    "\1\0\1\223\2\224\1\0\1\224\2\225\1\0\1\225"+
    "\2\226\1\0\1\226\2\227\1\0\1\227\2\230\1\0"+
    "\1\230\2\231\1\0\1\231\2\232\1\0\1\232\2\233"+
    "\1\0\1\233\2\234\1\0\1\234\2\235\1\0\1\235"+
    "\2\236\1\0\1\236\2\237\1\0\1\237\2\240\1\0"+
    "\1\240\2\241\1\0\1\241\2\242\1\0\1\242\2\243"+
    "\1\0\1\243\2\244\1\0\1\244\2\245\1\0\1\245"+
    "\2\246\1\0\1\246\2\247\1\0\1\247\2\250\1\0"+
    "\1\250\2\251\1\0\1\251\2\252\1\0\1\252\2\253"+
    "\1\0\1\253\2\254\1\0\1\254\2\255\1\0\1\255"+
    "\2\256\1\0\1\256\2\257\1\0\1\257\2\260\1\0"+
    "\1\260\2\261\1\0\1\261\2\262\1\0\1\262\2\263"+
    "\1\0\1\263\2\264\1\0\1\264\2\265\1\0\1\265"+
    "\2\266\1\0\1\266\2\267\1\0\1\267\2\270\1\0"+
    "\1\270\2\271\1\0\1\271\2\272\1\0\1\272\2\273"+
    "\1\0\1\273\2\274\1\0\1\274\2\275\1\0\1\275"+
    "\2\276\1\0\1\276\2\277\1\0\1\277\2\300\1\0"+
    "\1\300\2\301\1\0\1\301\2\302\1\0\1\302\2\303"+
    "\1\0\1\303\2\304\1\0\1\304\2\305\1\0\1\305"+
    "\2\306\1\0\1\306\2\307\1\0\1\307\2\310\1\0"+
    "\1\310\2\311\1\0\1\311\2\312\1\0\1\312\2\313"+
    "\1\0\1\313\2\314\1\0\1\314\2\315\1\0\1\315"+
    "\2\316\1\0\1\316\2\317\1\0\1\317\2\320\1\0"+
    "\1\320\2\321\1\0\1\321\2\322\1\0\1\322\2\323"+
    "\1\0\1\323\2\324\1\0\1\324\2\325\1\0\1\325"+
    "\2\326\1\0\1\326\2\327\1\0\1\327\2\330\1\0"+
    "\1\330\2\331\1\0\1\331\2\332\1\0\1\332\2\333"+
    "\1\0\1\333\2\334\1\0\1\334\2\335\1\0\1\335"+
    "\2\336\1\0\1\336\2\337\1\0\1\337\2\340\1\0"+
    "\1\340\2\341\1\0\1\341\2\342\1\0\1\342\2\343"+
    "\1\0\1\343\2\344\1\0\1\344\2\345\1\0\1\345"+
    "\2\346\1\0\1\346\2\347\1\0\1\347\2\350\1\0"+
    "\1\350\2\351\1\0\1\351\2\352\1\0\1\352\2\353"+
    "\1\0\1\353\2\354\1\0\1\354\2\355\1\0\1\355"+
    "\2\356\1\0\1\356\2\357\1\0\1\357\2\360\1\0"+
    "\1\360\2\361\1\0\1\361\2\362\1\0\1\362\2\363"+
    "\1\0\1\363\2\364\1\0\1\364\2\365\1\0\1\365"+
    "\2\366\1\0\1\366\2\367\1\0\1\367\2\370\1\0"+
    "\1\370\2\371\1\0\1\371\2\372\1\0\1\372\2\373"+
    "\1\0\1\373\2\374\1\0\1\374\2\375\1\0\1\375"+
    "\2\376\1\0\1\376\2\377\1\0\1\377\2\u0100\1\0"+
    "\1\u0100\2\u0101\1\0\1\u0101\2\u0102\1\0\1\u0102\2\u0103"+
    "\1\0\1\u0103\2\u0104\1\0\1\u0104\2\u0105\1\0\1\u0105"+
    "\2\u0106\1\0\1\u0106\2\u0107\1\0\1\u0107\2\u0108\1\0"+
    "\1\u0108\2\u0109\1\0\1\u0109\2\u010a\1\0\1\u010a\2\u010b"+
    "\1\0\1\u010b\2\u010c\1\0\1\u010c\2\u010d\1\0\1\u010d"+
    "\2\u010e\1\0\1\u010e\2\u010f\1\0\1\u010f\2\u0110\1\0"+
    "\1\u0110\2\u0111\1\0\1\u0111\2\u0112\1\0\1\u0112\2\u0113"+
    "\1\0\1\u0113\2\u0114\1\0\1\u0114\2\u0115\1\0\1\u0115"+
    "\2\u0116\1\0\1\u0116\2\u0117\1\0\1\u0117\2\u0118\1\0"+
    "\1\u0118\2\u0119\1\0\1\u0119\2\u011a\1\0\1\u011a\2\u011b"+
    "\1\0\1\u011b\2\u011c\1\0\1\u011c\2\u011d\1\0\1\u011d"+
    "\2\u011e\1\0\1\u011e\2\u011f\1\0\1\u011f\2\u0120\1\0"+
    "\1\u0120\2\u0121\1\0\1\u0121\2\u0122\1\0\1\u0122\2\u0123"+
    "\1\0\1\u0123\2\u0124\1\0\1\u0124\2\u0125\1\0\1\u0125"+
    "\2\u0126\1\0\1\u0126\2\u0127\1\0\1\u0127\2\110\1\0"+
    "\1\110";

  private static int [] zzUnpackTrans() {
    int [] result = new int[1172];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\2\0\2\1\1\11\4\1\1\0\1\1\2\0\2\1"+
    "\1\11\1\1\1\0\3\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\3\1\1\0\3\1"+
    "\1\0\3\1\1\0\3\1\1\0\1\1\1\11\337\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[295];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /** denotes if the user-EOF-code has already been executed */
  private boolean zzEOFDone;

  /* user code: */
    private StringBuilder buffer;
    private Character utf16BlockTmp = null;
    private int minLexLength = -1;
    private int currentLexLength = 0;
    private String sourceFile = null;

    public UnicodeFilteredReader(java.io.Reader in) {
        this(in, ZZ_BUFFERSIZE + 16);
    }

    public UnicodeFilteredReader(java.io.InputStream in) {
        this(in, ZZ_BUFFERSIZE + 16);
    }

    public void setSourceFile(String filename) {
        this.sourceFile = filename;
    }

    @Override
    public int read(char[] cbuf, int off, int len) throws IOException {
        if (len < 0) {
            throw new IndexOutOfBoundsException("len must not be negative");
        } else if (len == 0) {
            return 0;
        }
        synchronized(this.lock) {
            if (buffer == null) {
                throw new IOException("stream closed");
            }

            this.minLexLength = len - buffer.length();
            this.currentLexLength = 0;
            if (this.minLexLength > 0) {
                yylex();
            }
            this.minLexLength = -1;
            this.currentLexLength = 0;

            int read;
            int buflen = buffer.length();
            if (buflen == 0) {
                read = -1;
            } else if (len <= buflen) {
                read = len;
                buffer.getChars(0, len, cbuf, off);
                buffer.delete(0, len);
            } else {
                read = buflen;
                buffer.getChars(0, buflen, cbuf, off);
                buffer.delete(0, buflen);
            }
            return read;
        }
    }

    @Override
    public void close() throws IOException {
        synchronized(this.lock) {
            yyclose();
            buffer = null;
        }
    }

    private void error(String msg) throws LexerException {
        if (sourceFile != null) {
            throw new LexerException(msg, sourceFile, yyline + 1, yycolumn + 1);
        } else {
            throw new LexerException(msg, yyline + 1, yycolumn + 1);
        }
    }

    private void error(String msg, int line, int column) throws LexerException {
        if (sourceFile != null) {
            throw new LexerException(msg, sourceFile, line + 1, column + 1);
        } else {
            throw new LexerException(msg, line + 1, column + 1);
        }
    }


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public UnicodeFilteredReader(java.io.Reader in, int initialBufferSize) {
      if (initialBufferSize < 0) {
        throw new IllegalArgumentException("initial buffer size must not be negative");
    }
    this.buffer = new StringBuilder(initialBufferSize);
    this.zzReader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public UnicodeFilteredReader(java.io.InputStream in, int initialBufferSize) {
    this(new java.io.InputStreamReader(in), initialBufferSize);
  }

  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    char [] map = new char[0x10000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 22) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzCurrentPos*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = zzReader.read(zzBuffer, zzEndRead,
                                            zzBuffer.length-zzEndRead);

    if (numRead > 0) {
      zzEndRead+= numRead;
      return false;
    }
    // unlikely but not impossible: read 0 characters, but not at end of stream    
    if (numRead == 0) {
      int c = zzReader.read();
      if (c == -1) {
        return true;
      } else {
        zzBuffer[zzEndRead++] = (char) c;
        return false;
      }     
    }

	// numRead < 0
    return true;
  }

    
  /**
   * Closes the input stream.
   */
  private final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  private final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEOFDone = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  private final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  private final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  private final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  private final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  private final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  private void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private int yylex() throws java.io.IOException, LexerException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      boolean zzR = false;
      for (zzCurrentPosL = zzStartRead; zzCurrentPosL < zzMarkedPosL;
                                                             zzCurrentPosL++) {
        switch (zzBufferL[zzCurrentPosL]) {
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn++;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      zzState = ZZ_LEXSTATE[zzLexicalState];


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL)
            zzInput = zzBufferL[zzCurrentPosL++];
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = zzBufferL[zzCurrentPosL++];
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          int zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
        case 4: 
          { yybegin(UNICODE_ESCAPE);
          }
        case 6: break;
        case 3: 
          { yybegin(YYINITIAL); error("illegal unicode escape");
          }
        case 7: break;
        case 2: 
          { utf16BlockTmp = null;
                    buffer.append('\\');
                    currentLexLength++;
                    if (currentLexLength >= minLexLength) {
                        return 0;
                    }
          }
        case 8: break;
        case 1: 
          { utf16BlockTmp = null;
                    int yylen = zzMarkedPos - zzStartRead;
                    buffer.append(zzBuffer, zzStartRead, yylen);
                    currentLexLength += yylen;
                    if (currentLexLength >= minLexLength) {
                        return 0;
                    }
          }
        case 9: break;
        case 5: 
          { yybegin(YYINITIAL); 
                        char code = (char) Integer.parseInt(yytext(), 16);
                        Integer utf32;
                        if (utf16BlockTmp != null && (utf32 = utf16Decode(utf16BlockTmp, code)) != null) {
                            buffer.deleteCharAt(buffer.length() - 1);
                            buffer.appendCodePoint(utf32);
                            utf16BlockTmp = null;
                        } else {
                            utf16BlockTmp = code;
                            buffer.append(code);
                        }
                        currentLexLength++;
                        if (utf16BlockTmp == null && currentLexLength >= minLexLength) {
                            return 0;
                        }
          }
        case 10: break;
        default: 
          if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
            zzAtEOF = true;
            return YYEOF;
          } 
          else {
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
