/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package parser;

import lexer.LexerWrapper;
import lexer.Symbol;
import java.io.IOException;
//import java_cup.runtime.Symbol;

/**
 *
 * @author Michael Burzan
 */
public class RuleSwitcher {

    private int[] rules;
    private LexerWrapper lex;
    private Symbol symbol;

    public RuleSwitcher(Symbol symbol, LexerWrapper lex, int... s) {
        this.symbol = symbol;
        this.lex = lex;
        this.rules = s;
    }

    public boolean test() {

        if (this.symbol.sym == this.rules[0]) {
            //int length = 0;
            this.lex.mark();
            for (int i = 1; i < this.rules.length; i++) {
                try {
                    Symbol s = this.lex.yylex();
                    //length += this.lex.yylength();
                    if (s.sym != rules[i]) {
                        //this.lex.yypushback(length);
                        this.lex.reset();
                        return false;
                    }
                } catch (IOException ex) {
                    this.lex.reset();
                    return false;
                }
            }
            this.lex.reset();
            //   this.lex.yypushback(length);
            return true;
        }
        return false;
    }
}
