/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package resolve;

import java.util.ArrayList;
import java.util.List;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author Michael Burzan
 */
class SymbolEntry {

    private ClassFile file;
    private String key;

    public SymbolEntry(String key, ClassFile file) {
        this.key = key;
        this.file = file;
    }

    List<Integer> foundMethodParamCountList(String methodName) {
        List<MethodInfo> methods = file.getMethods(methodName);
        List<Integer> paramCountList = new ArrayList<>();
        for (MethodInfo info : methods) {
            paramCountList.add(info.getDescriptor().getParameterCount());
        }
        return paramCountList;
    }

    public String getPrimaryKey() {
        return this.key;
    }

    public String getSecondaryKey() {
        return this.file.getThis().getClassName();
    }
}
