/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package resolve;

import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import exceptions.CompilerException;
import teajay.bytecode.ClassFile;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author cefour
 * @deprecated
 */
public class SymbolTable {

    private LinkedList<SymbolEntry> symbolList = new LinkedList<>();
    private static SymbolTable instance = null;

    public static SymbolTable instance() {
        if (instance == null) {
            instance = new SymbolTable();
        }
        return instance;
    }

    private SymbolTable() {
    }

    public void addClass(String fileName, ClassFile file) throws CompilerException {
        if (!resolveWithoutLoader(fileName)) {
            String[] splitArray = fileName.split(System.getProperty("file.separator"));
            if (splitArray.length != 0) {
                symbolList.add(new SymbolEntry(splitArray[splitArray.length - 1].replace(".class", ""), file));
                return;
            }
            symbolList.add(new SymbolEntry(fileName.replace(".class", ""), file));
        }
        throw new CompilerException("Dublicate package" + fileName + "in project");

    }

    public boolean isMethodParamCountCorrect(String typeName, String methodName, int cnt) {
        SymbolEntry e = this.findEntry(typeName);
        Iterator<Integer> iter = e.foundMethodParamCountList(methodName).iterator();
        while (iter.hasNext()) {
            if (iter.next() == cnt) {
                return true;
            }
        }
        return true;
    }

    public String getFullQualifiedClassName(String typeName) throws CompilerException {
        SymbolEntry e = findEntry(typeName);
        if (e == null) {
            throw new CompilerException("Type " + typeName + " not found");
        }
        return e.getSecondaryKey();
    }

    private SymbolEntry findEntry(String typeName) {
        for (SymbolEntry e : symbolList) {
            if (e.getPrimaryKey().equals(typeName)) {
                return e;
            }
        }
        return null;
    }

    public boolean resolve(String qualifiedIdentifier) throws ByteCodeException, IOException, CompilerException {
        return resolveWithLoader(qualifiedIdentifier);
    }

    public String toString() {
        String buf = "";
        for (SymbolEntry e : symbolList) {
            buf += e.getPrimaryKey() + " : " + e.getSecondaryKey() + "\n";
        }
        return buf;
    }

    private boolean resolveWithoutLoader(String qualifiedIdentifier) {
        for (SymbolEntry e : symbolList) {
            if (e.getSecondaryKey().equals(qualifiedIdentifier)) {
                return true;
            }
        }
        for (SymbolEntry e : symbolList) {
            if (e.getPrimaryKey().equals(qualifiedIdentifier)) {
                return true;
            }
        }
        return false;
    }

    private boolean resolveWithLoader(String qualifiedIdentifier) throws ByteCodeException, IOException, CompilerException {
        Loader.instance().resolve(qualifiedIdentifier);
        return this.resolveWithoutLoader(qualifiedIdentifier);
    }
}
