/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.EnumDeclarationNode;
import abstractsyntaxtree.MethodeDeclaratorRestNode;
import abstractsyntaxtree.NormalClassDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClassDeclarationVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage1ClassDeclarationVisitor extends AbstractClassDeclarationVisitor {
    private final Stage1Environment stage1Env;

    public Stage1ClassDeclarationVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(NormalClassDeclarationNode node) throws CompilerException {
 
    }

    @Override
    public Visitor visit(NormalClassDeclarationNode node) throws CompilerException {
        return new Stage1NormalClassDeclartionVisitor(stage1Env);
    }

    @Override
    public void end(NormalClassDeclarationNode node) throws CompilerException {
 
    }

    @Override
    public Object getClassContainer() throws CompilerException {
        return null;
    }

    @Override
    public void begin(EnumDeclarationNode node) throws CompilerException {
 
    }

    @Override
    public Visitor visit(EnumDeclarationNode node) throws CompilerException {
        return new Stage1EnumDeclarationVisitor(stage1Env);
    }

    @Override
    public void end(EnumDeclarationNode node) throws CompilerException {
 
    }
    
}
