/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.InterfaceMethodDeclaratorRestNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractInterfaceGenericMethodDeclVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage1GenericInterfaceMethodDeclVisitor extends AbstractInterfaceGenericMethodDeclVisitor {
    private final Stage1Environment stage1Env;

    public Stage1GenericInterfaceMethodDeclVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
        //throw new CompilerException("Generic interface methods not implemented yet.", node.getSymbol());
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public void begin(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
    }
    /**
     * The generic parameter must be ignore: Example ignore T in  Stack<T extends Foo>  not Foo 
     * @param node
     * @return
     * @throws CompilerException 
     */
    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        stage1Env.createGenericMethodContext();
        return new Stage1GenericTypeParametersVisitor(stage1Env);
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {

    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(InterfaceMethodDeclaratorRestNode node) throws CompilerException {

    }
    
}
