/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.TypeArgumentNode;
import abstractsyntaxtree.TypeArgumentsListHelperNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeArgumentsListHelperVisitor;
import codegeneration.abstractvisitors.AbstractTypeArgumentsVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
public class Stage1GenericTypeArgumentsVisitor extends AbstractTypeArgumentsVisitor {
    private final Stage1Environment stage1Env;
    private final List<String> identifierList;

    public Stage1GenericTypeArgumentsVisitor(Stage1Environment stage1Env, List<String> typeArgumentIdentifierList) {
        this.stage1Env = stage1Env;
        this.identifierList = typeArgumentIdentifierList;
    }

    @Override
    public void begin(TypeArgumentNode node) throws CompilerException {
       
       
    }

    @Override
    public void begin(TypeArgumentsListHelperNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeArgumentNode node) throws CompilerException {
        return new Stage1TypeArgumentVisitor(stage1Env,new ArrayList<String>());
    }

    @Override
    public Visitor visit(TypeArgumentsListHelperNode node) throws CompilerException {
            return new AbstractTypeArgumentsListHelperVisitor() {
                List<String> identList = new ArrayList<>();
                @Override
                public void begin(TypeArgumentNode node) throws CompilerException {
                }

                @Override
                public Visitor visit(TypeArgumentNode node) throws CompilerException {
                    return new Stage1TypeArgumentVisitor(stage1Env,identList);
                }

                @Override
                public void end(TypeArgumentNode node) throws CompilerException {
                }
            };
    }

    @Override
    public void end(TypeArgumentNode node) throws CompilerException {
       
    }

    @Override
    public void end(TypeArgumentsListHelperNode node) throws CompilerException {
       
    }
    
}
