/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.GenericMethodeOrConstructorRestNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractGenericMethodeOrConstructorDeclVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
class Stage2GenericMethodOrConstructorDeclVisitor extends AbstractGenericMethodeOrConstructorDeclVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode> modis;
    private Stage2TypeParametersVisitor genericVisitor;

    public Stage2GenericMethodOrConstructorDeclVisitor(Stage2Environment stage2Env, List<ModifierNode> modis) {
        this.stage2Env = stage2Env;
        this.modis = modis;
    }

    Stage2GenericMethodOrConstructorDeclVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
        this.modis = Collections.EMPTY_LIST;
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
    }

    @Override
    public void begin(GenericMethodeOrConstructorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        return genericVisitor = new Stage2TypeParametersVisitor(stage2Env);
    }

    @Override
    public Visitor visit(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        String name = node.getIdentifier();
        //is a name not set, then is a construct. The constructor name is <init>
        if(name == null){
            name = "<init>";
        }
        return new Stage2GenericMethodOrConstructorRestVisitor(stage2Env,genericVisitor.getTypeParams(),modis,name);
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {
    }

    @Override
    public void end(GenericMethodeOrConstructorRestNode node) throws CompilerException {
    }
    
}
