/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.AnnotationTypeDeclarationNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.NormalInterfaceDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractInterfaceDeclarationVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
class Stage2InterfaceDeclarationVisitor extends AbstractInterfaceDeclarationVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> modifierList;

    public Stage2InterfaceDeclarationVisitor(Stage2Environment stage2Env, List<ModifierNode.Modifier> modifierList) {
        this.stage2Env = stage2Env;
        this.modifierList = modifierList;
    }

    @Override
    public void begin(NormalInterfaceDeclarationNode node) throws CompilerException {

    }

    @Override
    public void begin(AnnotationTypeDeclarationNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(NormalInterfaceDeclarationNode node) throws CompilerException {
        return new Stage2NormalInterfaceDeclarationVisitor(stage2Env,modifierList,node.getInterfaceName());
    }

    @Override
    public Visitor visit(AnnotationTypeDeclarationNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(NormalInterfaceDeclarationNode node) throws CompilerException {

    }

    @Override
    public void end(AnnotationTypeDeclarationNode node) throws CompilerException {

    }
    
}
