/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.DotIdentifierTypeArgumentsHelperNode;
import abstractsyntaxtree.TypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractReferenceTypeVisitor;
import codegeneration.environment.Stage2Environment;
import codegeneration.javavisitor.TypeArgumentsVisitor;
import exceptions.CompilerException;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2ReferenceTypeVisitor extends AbstractReferenceTypeVisitor {
    private final Stage2Environment stage2Env;
    private final List<String> identList;
    private Stage2TypeArgumentsVisitor stage2TypeArgumentsVisitor;
    private Stage2DotIdentifierTypeArgumentsHelperVisitor stage2DotIdentifierTypeArgumentsHelper;
    
    public Stage2ReferenceTypeVisitor(Stage2Environment stage2Env, List<String> identList) {
        this.stage2Env = stage2Env;
        this.identList = identList;
    }

    public List<Type> getTypeParameters() {
        if(stage2TypeArgumentsVisitor == null){
            if(stage2DotIdentifierTypeArgumentsHelper == null){
                return Collections.EMPTY_LIST;
            }
            return stage2DotIdentifierTypeArgumentsHelper.getTypeArguments();
        }
        return stage2TypeArgumentsVisitor.getTypes();
        
    }

    @Override
    public void begin(TypeArgumentsNode node) throws CompilerException {
       
    }

    @Override
    public Visitor visit(TypeArgumentsNode node) throws CompilerException {
        return stage2TypeArgumentsVisitor = new Stage2TypeArgumentsVisitor(stage2Env);
    }

    @Override
    public void end(TypeArgumentsNode node) throws CompilerException {
       
    }

    @Override
    public void begin(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
       identList.add(node.getIdentifier());
    }

    @Override
    public Visitor visit(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
        return stage2DotIdentifierTypeArgumentsHelper = new Stage2DotIdentifierTypeArgumentsHelperVisitor(stage2Env);
    }

    @Override
    public void end(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
       
    }
    
}
