/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.GenericMethodeOrConstructorRestNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractGenericMethodeOrConstructorDeclVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collection;
import java.util.List;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjImplGenericMethodOrConstructorDeclVisitor extends AbstractGenericMethodeOrConstructorDeclVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> flagList;
    private final Collection<List<MethodInfo>> methods;
    private Stage2TypeParametersVisitor stage2GenericType;
    private Stage2TjImplGenericMethodOrConstructorRestVisitor stage2GenericMethodOrConstructorRest;

    public Stage2TjImplGenericMethodOrConstructorDeclVisitor(Stage2Environment stage2Env, List<ModifierNode.Modifier> flagList, Collection<List<MethodInfo>> methods) {
        this.stage2Env = stage2Env;
        this.flagList = flagList;
        this.methods = methods;
        
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
        stage2Env.addGenericFrame();
        stage2Env.getTypeUtils().addFrame();
    }

    @Override
    public void begin(GenericMethodeOrConstructorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        return stage2GenericType = new Stage2TypeParametersVisitor(stage2Env);
    }

    @Override
    public Visitor visit(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        return stage2GenericMethodOrConstructorRest = new Stage2TjImplGenericMethodOrConstructorRestVisitor(stage2Env,flagList,methods,stage2GenericType.getTypeParams(),node.getIdentifier(),node.isVoid());
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {
        node.setGeneric(stage2GenericType.getTypeParams());
    }

    @Override
    public void end(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        if (!flagList.contains(ModifierNode.Modifier.STATIC)) {
            throw new CompilerException("Generic methods must be static for now. (To be implemented)");
        }        
        stage2Env.dropGenericFrame();
        stage2Env.getTypeUtils().removeFrame();
    
    }
    
}
