/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ClassDeclarationNode;
import abstractsyntaxtree.ConstructorDeclaratorRestHelperNode;
import abstractsyntaxtree.GenericMethodeOrConstructorDeclNode;
import abstractsyntaxtree.InterfaceDeclarationNode;
import abstractsyntaxtree.MethodeOrFieldDeclNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.VoidMethodeDeclaratorRestHelperNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMemberDeclVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collection;
import java.util.List;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjImplMemberDeclVisitor extends AbstractMemberDeclVisitor {
    private final Collection<List<MethodInfo>> methods;
    private final List<ModifierNode.Modifier> flagList;
    private final Stage2Environment stage2Env;

    

    Stage2TjImplMemberDeclVisitor(Stage2Environment stage2Env, List<ModifierNode.Modifier> flagList, Collection<List<MethodInfo>> methods) {
        this.stage2Env = stage2Env;
        this.flagList = flagList;
        this.methods = methods;
        if(methods == null){
            throw new Error("Fatal error: Method list is null ");
        }
    }

    @Override
    public void begin(MethodeOrFieldDeclNode node) throws CompilerException {
        
    }

    @Override
    public void begin(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
        
    }

    @Override
    public void begin(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
        
    }

    @Override
    public void begin(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        
    }

    @Override
    public void begin(ClassDeclarationNode node) throws CompilerException {
        throw new CompilerException("Inner class not supported in teajay impl", node.getSymbol());
    }

    @Override
    public void begin(InterfaceDeclarationNode node) throws CompilerException {
        throw new CompilerException("Inner interface not supported in teajay impl", node.getSymbol());
    }

    @Override
    public Visitor visit(MethodeOrFieldDeclNode node) throws CompilerException {
        return new Stage2TjImplMethodOrFieldVisitor(stage2Env,flagList,methods,node.getIdentifier());
    }

    @Override
    public Visitor visit(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
        return new Stage2TjImplVoidMethodDeclaratorRestHelperVistor(stage2Env,flagList,node.getMethodName());
    }

    @Override
    public Visitor visit(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
        return new Stage2TjImplConstructorDeclaratorRestHelperVisitor(stage2Env,flagList,node.getIdentifier(),methods);
    }

    @Override
    public Visitor visit(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        
        return new Stage2TjImplGenericMethodOrConstructorDeclVisitor(stage2Env,flagList,methods);   
    }

    @Override
    public Visitor visit(ClassDeclarationNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(InterfaceDeclarationNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(MethodeOrFieldDeclNode node) throws CompilerException {
        
    }

    @Override
    public void end(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
        
    }

    @Override
    public void end(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
        
    }

    @Override
    public void end(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        
    }

    @Override
    public void end(ClassDeclarationNode node) throws CompilerException {
        
    }

    @Override
    public void end(InterfaceDeclarationNode node) throws CompilerException {
    }
    
}

