/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeListVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.generics.parser.Type;
import teajay.runtime.exceptions.ResolveException;
import teajay.util.io.ClassFinder;

/**
 *
 * @author Michael Burzan
 */
class Stage2TypeListVisitor extends AbstractTypeListVisitor {

    private Stage2TypeVisitor stage2Type;
    private final Stage2Environment stage2Env;
    private List<Type> list = new ArrayList<>();

    public Stage2TypeListVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    public List<Type> getImplementsList() {
        return list;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return stage2Type = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
        Type t = stage2Type.getType();
        try {
            // check is Type a interface
            if (t instanceof Type.ClassType) {
                Type.ClassType classType = (Type.ClassType) t;
                if (ClassFinder.instance().find(classType.name).get().isInterface()) {
                    list.add(t);
                } else {
                    throw new CompilerException("Expecting interface ", node.getSymbol());
                }
            } else {
                throw new CompilerException("Expecting interface ", node.getSymbol());
            }
        } catch (ByteCodeException | IOException | ResolveException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }

    }

    @Override
    public Object getContainer() throws CompilerException {
        return null;
    }
}
