/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.BoundNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeParameterVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2TypeParameterVisitor extends AbstractTypeParameterVisitor {
    private final Stage2Environment stage2Env;
    private Stage2BoundVisitor stage2BoundVisitor;
    private List<Type> bounds = new ArrayList<>();
    public Stage2TypeParameterVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(BoundNode node) throws CompilerException {
       
    }

    @Override
    public Visitor visit(BoundNode node) throws CompilerException {
       return this.stage2BoundVisitor = new Stage2BoundVisitor(stage2Env);
    }

    @Override
    public void end(BoundNode node) throws CompilerException {
        bounds.add(stage2BoundVisitor.getBound());
    }
    
    public List<Type> getBounds(){
        return this.bounds;
    }
    
    
    
}
