/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.BlockStatementNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractBlockStatementsVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class Stage3BlockStatementsVisitor extends AbstractBlockStatementsVisitor {
    private final Stage3Environment stage3Env;
    private Stage3BlockStatementVisitor blockStatement;

    public Stage3BlockStatementsVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(BlockStatementNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(BlockStatementNode node) throws CompilerException {
        return blockStatement = new Stage3BlockStatementVisitor(stage3Env);
    }

    @Override
    public void end(BlockStatementNode node) throws CompilerException {

    }
    /**
     * 
     * @return true if block is empty
     */
    public boolean hasNoStatement(){
        if(blockStatement == null) return true;
        return this.blockStatement.hasNoStatement();
    }
    
}
