/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ClosureEnvListNode;
import abstractsyntaxtree.ExpressionNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureEnvVisitor;
import codegeneration.environment.Stage3Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.Map;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClosureEnvVisitor extends AbstractClosureEnvVisitor {
    private final Stage3Environment stage3Env;
    private Stage3ClosureEnvListVisitor closureEnvList;

    public Stage3ClosureEnvVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(ClosureEnvListNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ClosureEnvListNode node) throws CompilerException {
        return closureEnvList = new Stage3ClosureEnvListVisitor(stage3Env);
    }

    @Override
    public void end(ClosureEnvListNode node) throws CompilerException {
    }
    
    public Map<String, Pair<Type, ExpressionNode>> getEnvironmentList(){
        if(closureEnvList != null)
            return this.closureEnvList.getClosureEnvironment();
        return Collections.EMPTY_MAP;
    }
    
}
