/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureReturnVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClosureReturnVisitor extends AbstractClosureReturnVisitor {

    private final Stage3Environment stage3Env;
    private Stage3TypeVisitor typeVisitor;

    public Stage3ClosureReturnVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
        
    }

    public Type getType() throws CompilerException {
        return this.typeVisitor.getType();
    }
}
