/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.AssignmentOperatorNode;
import abstractsyntaxtree.Expression1Node;
import abstractsyntaxtree.InfixOpNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractExpressionVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.Deque;

/**
 *
 * @author Michael Burzan
 */
public class Stage3ExpressionVisitor extends AbstractExpressionVisitor {

    private final Stage3Environment stage3Env;
    private final Deque<InfixOpNode.InfixOps> stack;
    private final boolean hasDup;

    public Stage3ExpressionVisitor(Stage3Environment stage3Env, Deque<InfixOpNode.InfixOps> stack, boolean hasDup) {
        this.stage3Env = stage3Env;
        this.stack = stack;
        this.hasDup = hasDup;

    }

    @Override
    public void begin(Expression1Node node) throws CompilerException {
    }

    @Override
    public void begin(AssignmentOperatorNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(Expression1Node node) throws CompilerException {
        return new Stage3Expression1Visitor(stage3Env, this.stack, hasDup);
    }

    @Override
    public void visit(AssignmentOperatorNode node) throws CompilerException {
    }

    @Override
    public void end(Expression1Node node) throws CompilerException {
        
    }

    @Override
    public void end(AssignmentOperatorNode node) throws CompilerException {
    }
}
