/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ForVarControlRestNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.VariableDeclaratorIdNode;
import abstractsyntaxtree.VariableModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractForVarControlVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import teajay.bytecode.attributes.code.Label;

/**
 *
 * @author Michael Burzan
 */
class Stage3ForVarControlVisitor extends AbstractForVarControlVisitor {
    private final Stage3Environment stage3Env;
    private Stage3TypeVisitor typeVisitor;
    private String name;
    private Stage3ForVarControlRestVisitor forVarControlRest;
    private Label label;
    private Label loopLabel;

    public Stage3ForVarControlVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(VariableModifierNode node) throws CompilerException {

    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
        this.stage3Env.getLocalTable().addFrame();
    }

    @Override
    public void begin(VariableDeclaratorIdNode node) throws CompilerException {

    }

    @Override
    public void begin(ForVarControlRestNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(VariableModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public void visit(VariableDeclaratorIdNode node) throws CompilerException {
        name = node.getName();
    }

    @Override
    public Visitor visit(ForVarControlRestNode node) throws CompilerException {
        return forVarControlRest = new Stage3ForVarControlRestVisitor(stage3Env,typeVisitor.getType(),name);
    }

    @Override
    public void end(VariableModifierNode node) throws CompilerException {

    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(VariableDeclaratorIdNode node) throws CompilerException {

    }

    @Override
    public void end(ForVarControlRestNode node) throws CompilerException {
        this.label = forVarControlRest.getLabel();
        this.loopLabel = forVarControlRest.getLoopLabel();
    }
    
    public Label getLabel(){
        return this.label;
    }
    
    public Label getLoopLabel(){
        return this.loopLabel;
    }
    
}
