/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.VariableDeclaratorsNode;
import abstractsyntaxtree.VariableModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractLocalVariableDeclarationsStatementVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage3LocalVariableDeclarationsStatementVisitor extends AbstractLocalVariableDeclarationsStatementVisitor {
    private final Stage3Environment stage3Env;
    private Stage3TypeVisitor typeVisitor;

    public Stage3LocalVariableDeclarationsStatementVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(VariableModifierNode node) throws CompilerException {

    }

    @Override
    public void begin(TypeNode node) throws CompilerException {

    }

    @Override
    public void begin(VariableDeclaratorsNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(VariableModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public Visitor visit(VariableDeclaratorsNode node) throws CompilerException {
        return new Stage3VariableDeclaratorsVisitor(stage3Env,typeVisitor.getType());
    }

    @Override
    public void end(VariableModifierNode node) throws CompilerException {

    }

    @Override
    public void end(TypeNode node) throws CompilerException {
        if (node.getEdgeClampsOpenCloseList() != null && !node.getEdgeClampsOpenCloseList().isEmpty()) {
            throw new CompilerException("Cannot declare Java-Arrays", node.getSymbol());
        }
    }

    @Override
    public void end(VariableDeclaratorsNode node) throws CompilerException {

    }
    
}
