/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TjTypeDefBodyNode;
import abstractsyntaxtree.TypeListNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTjTypeDefVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.List;
import stage3.utils.TypeChecker;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 *
 *
 * typedef foo<T extends String> extends Bar<List<String>> {
 *
 * }
 *
 *
 *
 */
class Stage3TjTypeDefVisitor extends AbstractTjTypeDefVisitor {

    private Type extendsType;
    private List<Type> implementsList;
    private final Stage3Environment stage3Env;

    public Stage3TjTypeDefVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
        this.extendsType = new Type.ClassType(null, "java/lang/Object", null);
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
        this.extendsType = node.getType();
        TypeChecker checker = new TypeChecker(extendsType, stage3Env, node);
        checker.check();
    }

    @Override
    public void begin(TypeListNode node) throws CompilerException {
        this.implementsList = node.getTypeList();
        TypeChecker checker;
        for (Type t : implementsList) {
            checker = new TypeChecker(t, stage3Env, node);
            checker.check();
        }
    }

    @Override
    public void begin(TjTypeDefBodyNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TypeListNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TjTypeDefBodyNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
    }

    @Override
    public void end(TypeListNode node) throws CompilerException {
    }

    @Override
    public void end(TjTypeDefBodyNode node) throws CompilerException {
    }

    @Override
    public void begin(ModifierNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(ModifierNode node) throws CompilerException {
    }
}
