/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.adaptedvisitor;

import abstractsyntaxtree.BlockStatementsNode;
import codegeneration.Visitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import stage3.Stage3BlockVisitor;
import teajay.bytecode.cpool.ClassInfo;

/**
 *
 * @author Michael Burzan
 */
public class AdaptedTypeSwitchBlockVisitor extends Stage3BlockVisitor{
    private final ClassInfo classInfo;
    private final int index;
    private final Stage3Environment stage3Env;
    public AdaptedTypeSwitchBlockVisitor(Stage3Environment stage3Env, ClassInfo classInfo, int index){
        super(stage3Env);
        this.stage3Env = stage3Env;
        this.classInfo = classInfo;
        this.index = index;
    }

    @Override
    public Visitor visit(BlockStatementsNode node) throws CompilerException {
        return new AdaptedTypeSwitchBlockStatementsVisitor(stage3Env,classInfo,index);
    }
}
