/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.lang;

import java.lang.invoke.MethodHandle;
import teajay.util.TJType;
import teajay.util.tjattribute.TeaJayAttribute;

/**
 * For future use of MethodPointers.
 * @author Michael Kußmann <michi@outx.de>
 */
@TJType(type = TeaJayAttribute.Type.Hidden)
public class MethodPointer extends Closure {
    private final MethodHandle handle;
    /**
     *
     * @param handle
     */
    public MethodPointer(MethodHandle handle) {
        this.handle = handle;
    }

    @Override
    public Object execute(Object... params) throws Throwable {      
        return handle.invoke(params);
    }

}
