/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.lang;

/**
 * TeaJay compatible Comparable interface.
 * @author Michael Kußmann <michi@outx.de>
 */
public interface TJComparable<T> {
    /**
     * Compare this object to <tt>other</tt>.
     * @param other another Object
     * @return positive integer for this &gt; other ; 0 for this == other ; negative integer for this &lt; other
     */
    Number tjCompareTo(T other);
}
