/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.util;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class QIDTools {
    public static String toInternal(String qid) {
        return qid.replace('.', '/');
    }
    
    public static String toExternal(String qid) {
        return qid.replace('/', '.');
    }

    public static String simpleName(String qid) {
        int index = qid.lastIndexOf("/");
        if (index < 0) {
            return qid;
        }
        return qid.substring(index + 1);
    }
    
    public static String packageName(String qid) {
        int index = qid.lastIndexOf("/");
        if (index < 0) {
            return null;
        }
        return qid.substring(0, index);
    }
    
    public static boolean samePackage(String pkg1, String pkg2) {
        if (pkg1 != null && pkg2 != null && pkg1.equals(pkg2)) {
            return true;
        }
        return pkg1 == pkg2;
    }
}
