/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.util.io;

/**
 * ASCII progress animation.
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class ProgressToggler {

    private int toggle = 0;
    private boolean hasToggled;
    private String prefix = "";

    public String toggle() {
        hasToggled = true;
        toggle++;
        switch ((toggle - 1) % 4) {
            case 0:
                return prefix + "|";
            case 1:
                return prefix + "/";
            case 2:
                return prefix + "-";
            case 3:
                String tmp = prefix + "\\";
                if (toggle % 8 == 0) {
                    toggle = 0;
                    prefix = prefix + ".";
                }
                return tmp;
            default:
                throw new AssertionError(toggle);
        }
    }

    public boolean hasToggled() {
        return hasToggled;
    }
}
